Imports System.Math

Module General
    'variable booleane
    Public Attente, crochet_TS As Boolean
    Public Ferraillage_haut, DTU, CCTG, Tass As Boolean
    'Variables entires
    Public ancrage, angle1, angle2, angle3, choix, fe, fc, feuillehypo, fis, fouille, geom, Icrochet As Integer  '
    Public nbag, nbap, nbLit, NLit_TS(3), nacomb, nasacomb, nasahcomb, nbcomb, nasbcomb As Integer
    Public nasbhcomb, nsem, nsmax, nbarA, nbarAh, nbarB, nbarBh, nbha As Integer
    Public Position_chainage, Rang, Sism, Type_acier, Voile As Integer
    'Variables dcimales doubles
    Public a, Abas, Ahaut, aL, alpha, assa, assah, assb, assbh As Double
    Public b, Bbas, Bhaut, bL, cadre As Double ', cofp, cofs
    Public dsb, dss, ELS, ELU, enr, espvoile, espmin, espMax, espa, espb As Double
    Public gamaB, gamaS, h, hL, Ha, HAvoile, hf As Double
    Public ilA, ilAh, ilATS, ilB, ilBh, ilBTS, iretA, iretAh, iretATS, iretB, iretBh, IretBTS As Double
    Public la, lah, laTS, lb, lbh, lbTS, lc, lc1, lc2, lcinf, lcsup, moment, ms1(4) As Double
    Public Lvoile, ntaumax As Double
    Public phiA, phiAh, phib, phiBh, pa, pb, propDeb, propEp, q, rm As Double
    Public smax, St, Si, Sd, Sc, sigma_beton As Double 'sdens,
    Public taul, taull, taumax, tol1 As Double
    Public Vu, vulim, xamax, xbmax As Double 'utot, vbp, volp, vols, volt,
    'tableaux decimales simples
    Public calcc(2), EM(16), p(2, 4), mx(2, 4), mty(2, 4) As Double
    Public Hx(2, 4), dio(10) As Double
    Public Hy(2, 4), comb(2, 4), z(16) As Double 'xl(10)pHA(10),,
    'Variables chaine de caractres
    Public nom, nomaffaire, ingenieur, l_strFileName, msg As String '
    Public F_a$, F_b$, F_h$, F_q$
    Public F_p$(2, 4)
    Dim espacement_transversal() As Integer = {200, 300, 300, 300, 300, 300, 300, 200, 150, 100, 100}
    Dim nom_TS() As String = {"ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 45", "ST 50", "ST 60", "ST 25C", "ST 40C", "ST 65C"}
    Dim section_longitudinale() As Single = {1.19, 1.88, 2.57, 2.83, 3.85, 4.24, 5.03, 6.36, 2.57, 3.85, 6.36}
    Dim section_transversale() As Single = {1.19, 1.28, 1.28, 1.28, 1.28, 1.68, 1.68, 2.51, 2.57, 3.85, 6.36}

    'Variables base de donnes
    'Public rs As New Recordset()
    'Public cnn As New Connection()

    'Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

    'Public Function WinDir$()
    '    Dim temp$, wLen&
    '    'dtermine le dossier Windows
    '    temp$ = Space$(255)
    '    wLen& = GetWindowsDirectory(temp$, Len(temp$))
    '    WinDir$ = Left$(temp$, wLen&)
    'End Function
    Public Sub Mise_a_zero_generale()
        'mise  zro gnrale de toutes les variables publiques
        Dim i As Integer
        nomaffaire = "" : ingenieur = ""
        Call Initialisation_Materiaux()
        Call Mise_a_zero_geometrie()
        Call Mise_a_zero_charge()
        Call Mise_a_zero_valeurs_de_calcul()
        Tass = False : alpha = 0
        For i = 1 To 16
            z(i) = 0 : EM(i) = 0
        Next i
    End Sub
    Public Sub Mise_a_zero_geometrie()
        'mise  zro gnrale de toutes les variables conditionnant la gomtrie
        'des divers lments
        nom = "" : nsem = 0
        geom = 0
        choix = 1
        aL = 0 : bL = 0
        hL = 0 : q = 0 : hf = 0
        pa = 0 : pb = 0 : nbag = 0 : nbap = 0 : Ha = 0
        a = 0 : b = 0
        Voile = 0 : Lvoile = 0 : HAvoile = 0 : espvoile = 0 'voile
        Position_chainage = 0 : Type_acier = 1 : nbLit = 1 : Sism = 2
        Attente = False : Rang = 0
        lcsup = 0 : lcinf = 0
        crochet_TS = False : Ferraillage_haut = False
        DTU = True : CCTG = False 'calcul suivant DTU uniquement
        propEp = 0.03 : propDeb = 0.05 : fouille = 1 'epaisseur et dbord du bton de propret, semelle avec coffrage
    End Sub
    Public Sub Mise_a_zero_charge()
        'mise  zro gnrale de toutes les variables conditionnant les charges et
        'combinaisons supports par les divers lments
        Dim i, j As Integer
        For i = 1 To 2
            For j = 1 To 4
                p(i, j) = 0
                mx(i, j) = 0
                mty(i, j) = 0
                Hx(i, j) = 0
                Hy(i, j) = 0
                comb(i, j) = 0
            Next j
        Next i
    End Sub
    Public Sub Mise_a_zero_valeurs_de_calcul()
        phiA = 0 : phiAh = 0 : phib = 0 : phiBh = 0 'diamtres des aciers haut et bas de la semelle suivant les cts A et B
        assa = 0 : assb = 0 : assah = 0 : assbh = 0
        nbarA = 0 : phiA = 0 : ilA = 0 : iretA = 0 : la = 0
        nbarB = 0 : phib = 0 : ilB = 0 : iretB = 0 : lb = 0
        lc1 = 0 : lc2 = 0
    End Sub
    Public Sub Initialisation_Materiaux()
        ''initialisation des donnes  la mise en route du programme
        ''----------------------------------------------------------------------------------------
        '' fichier hypothses
        ''________________________________________________________________________________________
        'tol1 = 1.01 'Tolerance sur les Resultats
        'rm = 5      'Rayon du Mandrin de Cintrage en Diametres
        'fe = 500
        'fc = 25
        'Type_acier = 2 'barres HA
        'crochet_TS = False : nbLit = 1
        'gamaB = 1.5 : gamaS = 1.15
        'dsb = 0.025 'Poids specifique Beton (0.025 MN/m3)
        'dss = 0.018 'Poids Specifique moyenSol (0.018 MN/m3)
        'ELU = 1.35 : ELS = 1
        'espmin = 0.1 'espacement mini entre barres
        'espMax = 0.33 'espacement maxi entre barres
        'enr = 0.03 'enrobage des aciers
        'angle1 = 135 'angle crochet semelle
        'angle2 = 135 'angle cadre
        'angle3 = 180 'angle pingle et trier
        'fis = 1  'fissuration peu prjudiciable
    End Sub
    Public Sub Initialisation()
        'initialisation des donnes  la mise en route du programme
        Dim i, j As Integer
        nomaffaire = "Exemple 1" : ingenieur = "BAEL 99"
        ''----------------------------------------------------------------------------------------
        ''fichier gomtrie de la semelle
        ''----------------------------------------------------------------------------------------
        choix = 1
        aL = 6 : bL = 4 ' 'aL = 4 : bL = 6 
        hL = 0 : q = 0.35 : nom = "S6" : hf = 0.8 : nsem = 3 : geom = 1
        pa = 0.6 : pb = 0.4 : nbag = 4 : nbap = 3 : a = 0 : b = 0 : Ha = 0.012 ' pa = 0.4 : pb = 0.6 : nbag = 3 : nbap = 4 '
        Position_chainage = 0 : Attente = False : Rang = 0
        ''----------------------------------------------------------------------------
        '' fichiers charges
        ''----------------------------------------------------------------------------
        i = 1 : j = 1
        p(i, j) = 1.17
        mx(i, j) = 0
        mty(i, j) = 0.13
        Hx(i, j) = 0
        Hy(i, j) = 0
        comb(i, j) = 0
        i = 2 : j = 1
        p(i, j) = 0.86
        mx(i, j) = 0
        mty(i, j) = 0.09
        Hx(i, j) = 0
        Hy(i, j) = 0
        comb(i, j) = 0
    End Sub
    Public Function CheckAscii(ByVal KeyAscii As Integer) As Integer
        'Ne permettre que la saisie de chiffres, ignorer
        'tout le reste
        CheckAscii = Abs(KeyAscii)
        If KeyAscii < 0 Then
            'Si KeyAscii est transmis sous forme ngative  la routine de vrification, la virgule
            'est galement permise
            If Abs(KeyAscii) = 44 Then
                Exit Function
            End If
        End If
        If Abs(KeyAscii) = 45 Then Exit Function ' touche - (moins) utilisable
        If Abs(KeyAscii) = 8 Then Exit Function ' touche <-- (del) utilisable
        If Abs(KeyAscii) = 44 Then Exit Function
        If Abs(KeyAscii) < 48 Or Abs(KeyAscii) > 57 Then CheckAscii = 0
    End Function
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox, _
                                ByVal positif As Boolean)
        Dim keyAscii, i As Integer
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then
            text1.Clear()
        End If
        If keyAscii = Asc(".") Then
            text1.Text = text1.Text + ","
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If positif = True Then 'seulement si la valeur >0
            If keyAscii = Asc("-") Then
                text1.Text = text1.Text + "6"
                text1.SelectionStart = Len(text1.Text) + 1
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = CheckAscii(keyAscii)
        If keyAscii = 0 Then ee.Handled = True
    End Sub

End Module
