Imports System.Math
Imports System.Drawing.Printing
Public Class frmDessin
    Inherits System.Windows.Forms.Form
    Private WithEvents pdoc As New PrintDocument()
    'Dim aa, bb, cx, cy, h1, h2, h3, hauteur, hh, hhpl, eenr, eer, largeur, ll, ll1, ll2, lld As Double
    'Dim orix, oriy, oriyb, sst, wat, wbt As Double
#Region " Code gnr par le Concepteur Windows Form "

    Public Sub New()
        MyBase.New()

        'Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()

        'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()

    End Sub

    'La mthode substitue Dispose du formulaire pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmDessin))
        Me.SuspendLayout()
        '
        'frmDessin
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(826, 485)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "frmDessin"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Dessin"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.ResumeLayout(False)

    End Sub

#End Region



    Private Sub mnuConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim ppd As New PrintPreviewDialog()

        Try
            ppd.Document = pdoc
            ppd.ShowDialog()
        Catch exp As Exception
            MessageBox.Show("Pas d'imprimante connecte !", Me.Text, _
                 MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
        'PageSetupDialog1.ShowDialog()

    End Sub

    Private Sub mnuImprimer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'Call Impression_dessin()
        'PrintDialog1.ShowDialog()
        Dim printer As String
        Dim dialog As New PrintDialog()
        dialog.Document = pdoc

        If dialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            ' Specify the printer to use.
            'Dim psdlg As PageSetupDialog = New PageSetupDialog
            'With psdlg
            '    .PageSettings.PrinterResolution = Printing.PrinterResolutionKind.Low
            'End With
            printer = pdoc.PrinterSettings.PrinterName
            'pdoc.PrinterSettings.DefaultPageSettings.PrinterResolution.Kind()
            AddHandler pdoc.PrintPage, AddressOf pdoc_PrintPage
            pdoc.Print()
            pdoc.Dispose()
            dialog.Dispose()
        End If
    End Sub

    Private Sub pdoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdoc.PrintPage
        ' cette procdure permet le trace du poteau calcul sur l'imprimante  l'echelle 1/20
        Dim ge As Graphics = e.Graphics
        Call Imp_Dessin(ge)


    End Sub

    Private Sub Imp_Dessin(ByVal ge As Graphics)
        ' cette procdure permet le trace de la poutre calcule sur l'imprimante  l'echelle 1/20
        Dim w As SizeF
        Dim OriX, oriY, x, y, x1, y1, debord, hauteur, largeur, w1, red, redw As Single
        Dim z As PageSetupDialog
        Dim marginLeft, marginTop As Int32
        Dim myPen As New Pen(Color.Black, 0.1)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim myfont As New Font("Times New Roman", 12, FontStyle.Bold)
        Dim i, i1, i3, j As Integer

        'zz1 = PrinterUnitConvert.Convert(zz1, PrinterUnit.Display, PrinterUnit.TenthsOfAMillimeter)
        ge.PageUnit = GraphicsUnit.Millimeter

    End Sub
    Private Sub Frmdessin_Paint(ByVal sender As Object, ByVal pe As PaintEventArgs) Handles MyBase.Paint
        Dim g As Graphics = pe.Graphics
        Dim myPen As New Pen(Color.Black, 1)
        Dim myFont As New Font("Times New Roman", 24)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim aa, cx, cy, eenr, esp, hh, h1, h2, ilbb, llcsup, llcinf, llc1, llc2, ori, ppa, red, rmphiA, xa, x11 As Double
        Dim x, y, x1, y1, startAngle, sweepAngle As Single
        Dim N, nesp, i, j As Integer
        Dim w As SizeF
        Dim msg, msg1, msg2 As String
        Dim F_pa, F_pb, F_lcsup, F_lcinf, F_nsem, F_nbarA, F_phiA, F_ilA, F_espa, F_nbarB, F_phiB, F_ilB, F_espb As String
        Dim F_nbha, F_ha, F_lc, F_espVoile, F_la, F_lb, F_iretA, F_iretB, F_lc1, F_lc2, F_ilATS, F_ilBTS As String
        Dim espacement_transversal() As Integer = {200, 300, 300, 300, 300, 300, 300, 200, 150, 100, 100}
        Dim nom_TS() As String = {"ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 45", "ST 50", "ST 60", "ST 25C", "ST 40C", "ST 65C"}
        Select Case geom
            Case 1, 2, 3 'semelle isole ou filante arme
                h1 = Me.Width
                h2 = Me.Height
                cx = h1 / 2 : cy = (2 * h2 / 3)
                red = 6 '45
                If a > 3 Then red = 3 '25
                Call Reduction_dim_geometrique(red, aa, ppa, hh, eenr, llcsup, llcinf, llc1, rmphiA, llc2, ilbb)
                If iretA = 0 Then rmphiA = 0 'sert au positionnement de l'ancrage
                xa = (aa - ppa) / 2
                ori = cx - aa / 2
                ori = Fix(ori)
                ' dessin semelle
                myPen = New Pen(Color.Black, 2)
                x = CSng(ori) : y = CSng(cy) : x1 = CSng(ori + aa) : y1 = CSng(cy)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori) : y = CSng(cy) : x1 = CSng(ori) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + aa) : y = CSng(cy) : x1 = CSng(ori + aa) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori) : y = CSng(cy - hh) : x1 = CSng(ori + xa) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + aa) : y = CSng(cy - hh) : x1 = CSng(ori + xa + ppa) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + xa) : y = CSng(cy - hh) : x1 = CSng(ori + xa) : y1 = CSng(cy - (hh + 100))
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + (xa + ppa)) : y = CSng(cy - hh) : x1 = CSng(ori + (xa + ppa)) : y1 = CSng(cy - (hh + 100))
                g.DrawLine(myPen, x, y, x1, y1)
                ' dessin armatures semelle et poteau
                myPen = New Pen(Color.Black, 1)
                'dessin des armatures du poteau ou du voile ancres dans la semelle
                Select Case Rang
                    Case 1 '1 acier central
                        x = CSng(ori + xa + ppa / 2) : y = CSng(cy - hh - llcsup) : y1 = CSng(cy - hh + llcinf)
                        g.DrawLine(myPen, x, y, x, y1)
                    Case 2 '2 aciers latraux
                        If lc1 <> 0 Then
                            x = CSng(ori + xa + eenr) : y = CSng(cy - (eenr + 6)) : x1 = CSng(ori + (xa + eenr)) : y1 = CSng(cy - (hh + llcsup))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - (eenr + 9)) : x1 = CSng(ori + (xa + ppa - eenr)) : y1 = CSng(cy - (hh + llcsup))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + eenr)) : y = CSng(cy - (eenr + 6)) : x1 = CSng(ori + (xa + eenr) + llc1) : y1 = CSng(cy - (eenr + 6))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - (eenr + 9)) : x1 = CSng(ori + (xa + ppa - eenr) - llc1) : y1 = CSng(cy - (eenr + 9))
                            g.DrawLine(myPen, x, y, x1, y1)
                        Else
                            x = CSng(ori + xa + eenr) : y = CSng(cy - hh - llcsup) : x1 = CSng(ori + (xa + eenr)) : y1 = CSng(cy - hh + llcinf)
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - hh - llcsup) : x1 = CSng(ori + (xa + ppa - eenr)) : y1 = CSng(cy - hh + llcinf)
                            g.DrawLine(myPen, x, y, x1, y1)
                        End If
                    Case Else 'x aciers centraux + 2 aciers latraux
                        N = (Rang - 2) + 1
                        x11 = ppa / N
                        For i = 1 To N - 1
                            x = CSng(ori + xa + i * x11) : y = CSng(cy - hh - llcsup) : x1 = CSng(ori + xa + i * x11) : y1 = CSng(cy - hh + llcinf)
                            g.DrawLine(myPen, x, y, x1, y1)
                        Next i
                        If lc1 <> 0 Then
                            x = CSng(ori + xa + eenr) : y = CSng(cy - (eenr + 6)) : x1 = CSng(ori + (xa + eenr)) : y1 = CSng(cy - (hh + llcsup))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - (eenr + 9)) : x1 = CSng(ori + (xa + ppa - eenr)) : y1 = CSng(cy - (hh + llcsup))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + eenr)) : y = CSng(cy - (eenr + 6)) : x1 = CSng(ori + (xa + eenr) + llc1) : y1 = CSng(cy - (eenr + 6))
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - (eenr + 9)) : x1 = CSng(ori + (xa + ppa - eenr) - llc1) : y1 = CSng(cy - (eenr + 9))
                            g.DrawLine(myPen, x, y, x1, y1)
                        Else
                            x = CSng(ori + xa + eenr) : y = CSng(cy - hh - llcsup) : x1 = CSng(ori + (xa + eenr)) : y1 = CSng(cy - hh + llcinf)
                            g.DrawLine(myPen, x, y, x1, y1)
                            x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - hh - llcsup) : x1 = CSng(ori + (xa + ppa - eenr)) : y1 = CSng(cy - hh + llcinf)
                            g.DrawLine(myPen, x, y, x1, y1)
                        End If
                End Select
                ' dessin armatures infrieures de la semelle
                '---- armatures longitudinales
                Select Case Type_acier
                    Case 1 'TS
                        x = CSng(ori + eenr + rmphiA + 3) : y = CSng(cy - eenr - 5)
                        x1 = 5 : y1 = 5
                        startAngle = 0 : sweepAngle = 360
                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                        x = CSng(ori + (aa - eenr - rmphiA) - 3) : y = CSng(cy - eenr - 5)
                        x1 = 5 : y1 = 5
                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                        Select Case nbLit
                            Case 1 '1 lit
                                espmin = espacement_transversal(NLit_TS(1))
                                nesp = CInt((a - 2 * enr) * 1000 / espmin)
                                esp = ((ori + aa - eenr) - (ori + eenr)) / nesp
                                nesp = nesp - 1
                                For i = 1 To nesp
                                    x = CSng(ori + eenr + rmphiA + i * esp) : y = CSng(cy - eenr - 5)
                                    x1 = 5 : y1 = 5
                                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                Next i

                            Case 2 '2lits
                                j = 2 '----------> DESSIN DU LIT 1
                                espmin = espacement_transversal(NLit_TS(j))
                                nesp = CInt((a - 2 * enr) * 1000 / espmin)
                                esp = ((ori + aa - eenr) - (ori + eenr)) / nesp
                                nesp = nesp - 1
                                For i = 1 To nesp
                                    x = CSng(ori + eenr + rmphiA + i * esp) : y = CSng(cy - eenr - 5)
                                    x1 = 5 : y1 = 5
                                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                Next i
                                j = 3 '----------> DESSIN DU LIT 2
                                espmin = espacement_transversal(NLit_TS(j))
                                If ilA <> ilB Then 'ilb=0.75*b
                                    x = CSng(ori + aa / 2 - ilbb / 2) : y = CSng(cy - eenr - 6) : x1 = CSng(ori + aa / 2 + ilbb / 2) : y1 = CSng(cy - eenr - 6)
                                    g.DrawLine(myPen, x, y, x1, y1)
                                    x = CSng(ori + aa / 2 - ilbb / 2) : y = CSng(cy - eenr - 11)
                                    x1 = 5 : y1 = 5
                                    startAngle = 0 : sweepAngle = 360
                                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                    x = CSng(ori + aa / 2 + ilbb / 2) : y = CSng(cy - eenr - 11)
                                    x1 = 5 : y1 = 5
                                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                    nesp = CInt(ilB * 1000 / espmin)
                                    esp = ilbb / nesp
                                    nesp = nesp - 1
                                    For i = 1 To nesp
                                        x = CSng(ori + aa / 2 - ilbb / 2 + i * esp) : y = CSng(cy - eenr - 11)
                                        x1 = 5 : y1 = 5
                                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                    Next i

                                Else
                                    nesp = CInt((a - 2 * enr) * 1000 / espmin)
                                    esp = ((ori + aa - eenr) - (ori + eenr)) / nesp
                                    nesp = nesp - 1
                                    For i = 1 To nesp
                                        x = CSng(ori + eenr + rmphiA + i * esp) : y = CSng(cy - eenr - 11)
                                        x1 = 5 : y1 = 5
                                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                                    Next i
                                End If
                        End Select
                    Case 2 'HA
                        x = CSng(ori + eenr + rmphiA + 3) : y = CSng(cy - eenr - 5)
                        x1 = 5 : y1 = 5
                        startAngle = 0 : sweepAngle = 360
                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                        x = CSng(ori + (aa - eenr - rmphiA) - 3) : y = CSng(cy - eenr - 5)
                        x1 = 5 : y1 = 5
                        g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                        nesp = nbarB - 1
                        esp = ((ori + aa - eenr - rmphiA) - (ori + eenr + rmphiA)) / nesp
                        nesp = nesp - 1
                        For i = 1 To nesp
                            x = CSng(ori + eenr + rmphiA + i * esp) : y = CSng(cy - eenr - 5)
                            x1 = 5 : y1 = 5
                            g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                        Next i
                End Select
                ''---- armatures transversales
                If iretA <> 0 Then
                    x = CSng(ori + eenr + rmphiA) : y = CSng(cy - eenr) : x1 = CSng(ori + (aa - eenr - rmphiA)) : y1 = CSng(cy - eenr)
                    g.DrawLine(myPen, x, y, x1, y1)
                    ' dessin crochet gauche armature transversale semelle
                    x = CSng(ori + eenr) : y = CSng(cy - eenr - 2 * rmphiA)
                    x1 = CSng(2 * rmphiA) : y1 = CSng(2 * rmphiA)
                    startAngle = 90 : sweepAngle = 135
                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                    x = CSng(ori + eenr + rmphiA + rmphiA * Cos(3 * PI / 4)) : y = CSng(cy - eenr - rmphiA - rmphiA * Sin(3 * PI / 4))
                    x1 = x + CSng(rmphiA * 0.707) : y1 = y - CSng(rmphiA * 0.707)
                    g.DrawLine(myPen, x, y, x1, y1)
                    'dessin crochet droit armature transversale semelle
                    x = CSng(ori + aa - eenr - 2 * rmphiA) : y = CSng(cy - eenr - 2 * rmphiA)
                    x1 = CSng(2 * rmphiA) : y1 = CSng(2 * rmphiA)
                    startAngle = 315 : sweepAngle = 135
                    g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                    x = CSng(ori + aa - eenr - rmphiA + rmphiA * Cos(PI / 4)) : y = CSng(cy - eenr - rmphiA - rmphiA * Sin(3 * PI / 4))
                    x1 = x - CSng(rmphiA * 0.707) : y1 = y - CSng(rmphiA * 0.707)
                    g.DrawLine(myPen, x, y, x1, y1)
                Else
                    x = CSng(ori + eenr) : y = CSng(cy - eenr) : x1 = CSng(ori + (aa - eenr)) : y1 = CSng(cy - eenr)
                    g.DrawLine(myPen, x, y, x1, y1)
                End If
                'Dsignation aciers poteau
                Select Case Rang
                    Case 0
                        'ne rien faire
                    Case 1
                        x = CSng(ori + xa + ppa / 2) : y = CSng(cy - (hh + 50)) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy - (hh + 50))
                        g.DrawLine(myPen, x, y, x1, y1)
                    Case Else
                        x = CSng(ori + (xa + eenr)) : y = CSng(cy - (hh + 50)) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy - (hh + 50))
                        g.DrawLine(myPen, x, y, x1, y1)
                        x = CSng(ori + (xa + ppa - eenr)) : y = CSng(cy - (hh + 40)) : x1 = CSng(ori + (xa + ppa + 40)) : y1 = CSng(cy - (hh + 40))
                        g.DrawLine(myPen, x, y, x1, y1)
                        x = CSng(ori + (xa + ppa + 40)) : y = CSng(cy - (hh + 40)) : x1 = CSng(ori + (xa + ppa + 40)) : y1 = CSng(cy - (hh + 50))
                        g.DrawLine(myPen, x, y, x1, y1)
                End Select
                'Dsignation aciers semelle ou chainage
                Select Case Type_acier
                    Case 1 'TS
                        Select Case nbLit
                            Case 1  '1 lit
                                x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy - eenr) : x1 = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y1 = CSng(cy + 100)
                                g.DrawLine(myPen, x, y, x1, y1)
                                x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy + 100) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy + 100)
                                g.DrawLine(myPen, x, y, x1, y1)
                            Case 2  '2 lits
                                'lit 1 = lit infrieur
                                x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy - eenr) : x1 = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y1 = CSng(cy + 100)
                                g.DrawLine(myPen, x, y, x1, y1)
                                x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy + 100) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy + 100)
                                g.DrawLine(myPen, x, y, x1, y1)
                                'lit 2 = lit suprieur
                                x = CSng(ori + eenr + rmphiA + 2 + nesp * esp) : y = CSng(cy - eenr - 6) : x1 = CSng(ori + eenr + rmphiA + 2 + nesp * esp) : y1 = CSng(cy + 50)
                                g.DrawLine(myPen, x, y, x1, y1)
                                x = CSng(ori + eenr + rmphiA + 2 + nesp * esp) : y = CSng(cy + 50) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy + 50)
                                g.DrawLine(myPen, x, y, x1, y1)
                        End Select
                    Case 2 'HA
                        'aciers transversaux
                        x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy - eenr) : x1 = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y1 = CSng(cy + 100)
                        g.DrawLine(myPen, x, y, x1, y1)
                        x = CSng(ori + eenr + rmphiA + (nesp - 1) * esp - 10) : y = CSng(cy + 100) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy + 100)
                        g.DrawLine(myPen, x, y, x1, y1)
                        'aciers longitudinaux
                        x = CSng(ori + eenr + rmphiA + 2 + nesp * esp) : y = CSng(cy - eenr - 2) : x1 = CSng(ori + eenr + rmphiA + 2 + nesp * esp) : y1 = CSng(cy + 50)
                        g.DrawLine(myPen, x, y, x1, y1)
                        x = CSng(ori + eenr + rmphiA + nesp * esp) : y = CSng(cy + 50) : x1 = CSng(ori + (aa + 200)) : y1 = CSng(cy + 50)
                        g.DrawLine(myPen, x, y, x1, y1)
                        x = CSng(ori + (aa - eenr - rmphiA)) : y = CSng(cy - eenr - 2) : x1 = CSng(ori + (aa - eenr - rmphiA)) : y1 = CSng(cy + 50)
                        g.DrawLine(myPen, x, y, x1, y1)
                End Select

                ' lignes de cotes
                'cote A x B
                x = CSng(ori) : y = CSng(cy + 150) : x1 = CSng(ori + aa) : y1 = CSng(cy + 150)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori) : y = CSng(cy + 147) : x1 = CSng(ori) : y1 = CSng(cy + 153)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + aa) : y = CSng(cy + 147) : x1 = CSng(ori + aa) : y1 = CSng(cy + 153)
                g.DrawLine(myPen, x, y, x1, y1)
                'cote H
                x = CSng(ori - 30) : y = CSng(cy) : x1 = CSng(ori - 30) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori - 27) : y = CSng(cy) : x1 = CSng(ori - 33) : y1 = CSng(cy)
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori - 27) : y = CSng(cy - hh) : x1 = CSng(ori - 33) : y1 = CSng(cy - hh)
                g.DrawLine(myPen, x, y, x1, y1)
                'cote a
                x = CSng(ori + xa) : y = CSng(cy - (hh + llcsup + 20)) : x1 = CSng(ori + (xa + ppa)) : y1 = CSng(cy - (hh + llcsup + 20))
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + xa) : y = CSng(cy - (hh + llcsup + 23)) : x1 = CSng(ori + xa) : y1 = CSng(cy - (hh + llcsup + 17))
                g.DrawLine(myPen, x, y, x1, y1)
                x = CSng(ori + xa + ppa) : y = CSng(cy - (hh + llcsup + 23)) : x1 = CSng(ori + (xa + ppa)) : y1 = CSng(cy - (hh + llcsup + 17))
                g.DrawLine(myPen, x, y, x1, y1)
                'cote lcsup et lcinf
                x = CSng(ori + xa - 33) : y = CSng(cy - (hh + llcsup)) : x1 = CSng(ori + (xa - 27)) : y1 = CSng(cy - (hh + llcsup))
                g.DrawLine(myPen, x, y, x1, y1)
                If lc1 = 0 Then
                    x = CSng(ori + xa - 30) : y = CSng(cy - (hh + llcsup)) : x1 = CSng(ori + (xa - 30)) : y1 = CSng(cy - hh + llcinf)
                    g.DrawLine(myPen, x, y, x1, y1)
                    x = CSng(ori + xa - 33) : y = CSng(cy - hh + llcinf) : x1 = CSng(ori + (xa - 27)) : y1 = CSng(cy - hh + llcinf)
                    g.DrawLine(myPen, x, y, x1, y1)
                Else
                    x = CSng(ori + xa - 30) : y = CSng(cy - (hh + llcsup)) : x1 = CSng(ori + (xa - 30)) : y1 = CSng(cy - hh)
                    g.DrawLine(myPen, x, y, x1, y1)
                End If
                ' affichage texte
                myFont = New Font("Times New Roman", 9, FontStyle.Regular)
                ' A x B
                Select Case geom
                    Case 1  'semelle isole
                        F_a = Format(a, "#0.00")
                        F_b = Format(b, "#0.00")
                        msg = F_a & " x " & F_b
                    Case 2, 3 'semelle filante
                        F_a = Format(a, "#0.00")
                        msg = F_a
                End Select
                w = g.MeasureString(msg, myFont)
                x = CSng(ori + aa / 2 - w.Width / 2)
                y = CSng(cy + 155)
                g.DrawString(msg, myFont, myBrush, x, y)
                ' H
                F_h = Format(h * 100, "##0")
                msg = F_h
                w = g.MeasureString(msg, myFont)
                x = CSng(ori - 40 - w.Width / 2)
                y = CSng(cy - hh / 2 - w.Height)
                g.DrawString(msg, myFont, myBrush, x, y)
                ' pa
                Select Case geom
                    Case 1 'semelle isole
                        F_pa = Format(pa, "#0.00")
                        F_pb = Format(pb, "#0.00")
                        msg = F_pa & " x " & F_pb
                    Case 2, 3 'semelle filante
                        F_pa = Format(Lvoile, "#0.00")
                        msg = F_pa
                End Select
                w = g.MeasureString(msg, myFont)
                x = CSng(ori + aa / 2 - w.Width / 2)
                y = CSng(cy - hh - llcsup - 30 - w.Height)
                g.DrawString(msg, myFont, myBrush, x, y)
                ' lcsup et son complment lcinf
                If lcsup <> 0 Then
                    F_lcsup = Format(lcsup * 100, "##0")
                    msg = F_lcsup
                    w = g.MeasureString(msg, myFont)
                    x = CSng(ori + xa - 40 - w.Width / 2)
                    y = CSng(cy - hh - llcsup / 2 - w.Height)
                    g.DrawString(msg, myFont, myBrush, x, y)
                    If lc1 = 0 Then
                        F_lcinf = Format(lcinf * 100, "##0")
                        msg = F_lcinf
                        w = g.MeasureString(msg, myFont)
                        x = CSng(ori + xa - 40 - w.Width / 2)
                        y = CSng(cy - hh + llcinf / 2 - w.Height)
                        g.DrawString(msg, myFont, myBrush, x, y)
                    End If
                End If
                ' Nom de la semelle
                myFont = New Font("Times New Roman", 12, FontStyle.Bold)
                Select Case geom
                    Case 1
                        msg = "Semelle : " & nom
                    Case 2, 3
                        msg = "Semelle filante : " & nom
                End Select
                w = g.MeasureString(msg, myFont)
                x = CSng(ori + aa / 2 - w.Width / 2)
                y = 15
                g.DrawString(msg, myFont, myBrush, x, y)
                ' Nombre de semelles identiques
                myFont = New Font("Times New Roman", 9, FontStyle.Regular)
                F_nsem = Format(nsem, "#0")
                msg = "Nombre de semelles identiques : " & F_nsem
                w = g.MeasureString(msg, myFont)
                x = CSng(ori + aa / 2 - w.Width / 2)
                y = 40
                g.DrawString(msg, myFont, myBrush, x, y)
                ' Coupe suivant A
                msg = "Coupe suivant A"
                w = g.MeasureString(msg, myFont)
                x = CSng(ori + aa / 2 - w.Width / 2)
                y = 60
                g.DrawString(msg, myFont, myBrush, x, y)
                'Aciers longitudinaux suivant A
                Select Case Type_acier
                    Case 1 'TS
                        Select Case nbLit
                            Case 1 '1 lit
                                msg1 = nom_TS(NLit_TS(1))
                                If geom = 3 Then
                                    msg2 = ""
                                ElseIf geom = 2 Then
                                    F_ilA = Format(ilA, "##.00")
                                    msg2 = " x " & F_ilA
                                Else
                                    F_ilA = Format(ilA, "##.00") : F_ilATS = Format(ilATS, "##.00")
                                    msg2 = "  " & F_ilA & " x " & F_ilATS
                                End If
                                msg = "Treillis soud  " & msg1 & msg2
                                w = g.MeasureString(msg, myFont)
                                x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy + 100 - w.Height)
                                g.DrawString(msg, myFont, myBrush, x, y)
                                '            msg1 = "Treillis soud pos dans le sens transversal"
                                '            h1 = TextHeight(msg1): w = TextWidth(msg1)
                                '            CurrentY = cy + 600 - h1: CurrentX = ori + (aa + 2000) - w
                                '            Print msg1
                            Case 2 '2 lits
                                '--> LIT 1
                                msg1 = nom_TS(NLit_TS(2))
                                If geom = 2 Then
                                    F_ilA = Format(ilA, "##.00")
                                    msg2 = " x " & F_ilA
                                Else
                                    F_ilA = Format(ilA, "##.00") : F_ilATS = Format(ilATS, "##.00")
                                    msg2 = "  " & F_ilA & " x " & F_ilATS
                                End If
                                msg = "Treillis soud  " & msg1 & msg2
                                w = g.MeasureString(msg, myFont)
                                x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy + 100 - w.Height)
                                g.DrawString(msg, myFont, myBrush, x, y)
                                '            msg1 = "Treillis soud pos dans le sens transversal"
                                '            h1 = TextHeight(msg1): w = TextWidth(msg1)
                                '            CurrentY = cy + 600 - h1: CurrentX = ori + (aa + 2000) - w
                                '            Print msg1
                                '--> LIT 2
                                msg1 = nom_TS(NLit_TS(3))
                                If geom = 2 Then
                                    F_ilB = Format(ilB, "##.00")
                                    msg2 = " x " & F_ilB
                                Else
                                    F_ilB = Format(ilB, "##.00") : F_ilBTS = Format(ilBTS, "##.00")
                                    msg2 = "  " & F_ilB & " x " & F_ilBTS
                                End If
                                msg = "Treillis soud  " & msg1 & msg2
                                w = g.MeasureString(msg, myFont)
                                x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy + 50 - w.Height)
                                g.DrawString(msg, myFont, myBrush, x, y)
                        End Select
                    Case 2 'HA
                        F_nbarA = Format(nbarA, "#0")
                        F_phiA = Format(phiA * 1000, "#0")
                        F_ilA = Format(ilA, "#0.00")
                        F_espa = Format(espa * 100, "#0.0")
                        msg = F_nbarA & " HA" & F_phiA & " x " & F_ilA & "  e= " & F_espa
                        w = g.MeasureString(msg, myFont)
                        x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy + 100 - w.Height)
                        g.DrawString(msg, myFont, myBrush, x, y)
                End Select
                'Aciers transversaux suivant B
                If Type_acier = 2 Then
                    F_nbarB = Format(nbarB, "#0")
                    F_phiB = Format(phib * 1000, "#0")
                    F_espb = Format(espb * 100, "#0.0")
                    Select Case geom
                        Case 1  'semelle isole
                            F_ilB = Format(ilB, "#0.00")
                            msg = F_nbarB & " HA" & F_phiB & " x " & F_ilB & "  e= " & F_espb
                        Case 2  'semelle filante
                            msg = F_nbarB & " HA" & F_phiB & "  e= " & F_espb

                    End Select
                    w = g.MeasureString(msg, myFont)
                    x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy + 50 - w.Height)
                    g.DrawString(msg, myFont, myBrush, x, y)
                End If
                'Aciers poteau/voile

                Select Case geom
                    Case 1  'semelle isole
                        F_nbha = Format(nbha, "#0")
                        F_ha = Format(Ha * 1000, "#0")
                        F_lc = Format(lc, "#0.00")
                        msg = F_nbha & " HA" & F_ha & " x " & F_lc
                        w = g.MeasureString(msg, myFont)
                        x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy - hh - 50 - w.Height)
                        g.DrawString(msg, myFont, myBrush, x, y)
                        'croquis acier poteau
                        'hauteur
                        x = CSng(Me.Width - 100 - llc1 / 2) : y = CSng(cy - hh - 75) : x1 = CSng(Me.Width - 100 - llc1 / 2) : y1 = CSng(cy - hh - 75 - llc2 / 2)
                        g.DrawLine(myPen, x, y, x1, y1)
                        If lc1 <> 0 Then
                            x = CSng(Me.Width - 100 - llc1 / 2) : y = CSng(cy - hh - 75) : x1 = CSng(Me.Width - 100) : y1 = CSng(cy - hh - 75)
                            g.DrawLine(myPen, x, y, x1, y1)
                        End If
                        'dim croquis acier poteau : longueur
                        F_lc2 = Format(lc2 * 100, "##0")
                        msg = F_lc2
                        w = g.MeasureString(msg, myFont)
                        x = CSng(Me.Width - 100 - llc1 / 2 + 2) : y = CSng(cy - hh - 75 - llc2 / 4 - w.Height)
                        g.DrawString(msg, myFont, myBrush, x, y)
                        'dim croquis acier poteau : retour
                        If lc1 <> 0 Then
                            F_lc1 = Format(lc1 * 100, "##0")
                            msg = F_lc1
                            w = g.MeasureString(msg, myFont)
                            x = CSng(Me.Width - 100 - llc1 / 4 - w.Width / 2) : y = CSng(cy - hh - 75 - w.Height)
                            g.DrawString(msg, myFont, myBrush, x, y)
                        End If
                    Case 2  'semelle filante
                        Select Case Voile
                            Case 1, 2 'voile bton
                                If Attente = True Then
                                    F_ha = Format(HAvoile * 1000, "#0")
                                    F_lc = Format(lc, "#0.00")
                                    F_espVoile = Format(espvoile * 100, "#0.0")
                                    msg = " HA" & F_ha & " x " & F_lc & "  e= " & F_espVoile
                                    w = g.MeasureString(msg, myFont)
                                    x = CSng(Me.Width - 50 - w.Width) : y = CSng(cy - hh - 50 - w.Height)
                                    g.DrawString(msg, myFont, myBrush, x, y)
                                    'croquis acier voile
                                    x = CSng(Me.Width - 100 - llc1 / 2) : y = CSng(cy - hh - 75) : x1 = CSng(Me.Width - 100 - llc1 / 2) : y1 = CSng(cy - hh - 75 - llc2 / 2)
                                    g.DrawLine(myPen, x, y, x1, y1)
                                    If lc1 <> 0 Then
                                        x = CSng(Me.Width - 100 - llc1 / 2) : y = CSng(cy - hh - 75) : x1 = CSng(Me.Width - 100) : y1 = CSng(cy - hh - 75)
                                        g.DrawLine(myPen, x, y, x1, y1)
                                    End If
                                    'dim croquis acier voile : longueur
                                    F_lc2 = Format(lc2 * 100, "##0")
                                    msg = F_lc2
                                    w = g.MeasureString(msg, myFont)
                                    x = CSng(Me.Width - 100 - llc1 / 2 + 2) : y = CSng(cy - hh - 75 - llc2 / 4 - w.Height)
                                    g.DrawString(msg, myFont, myBrush, x, y)
                                    'dim croquis acier voile : retour
                                    If lc1 <> 0 Then
                                        F_lc1 = Format(lc1 * 100, "##0")
                                        msg = F_lc1
                                        w = g.MeasureString(msg, myFont)
                                        x = CSng(Me.Width - 100 - llc1 / 4 - w.Width / 2) : y = CSng(cy - hh - 75 - w.Height)
                                        g.DrawString(msg, myFont, myBrush, x, y)
                                    End If
                                End If
                            Case 3, 4 'mur en maonnerie
                                'aucun acier en attente
                        End Select

                End Select

                Select Case Type_acier
                    Case 1 'TS

                    Case 2 'HA
                        'Dessin caractristiques aciers  suivant B
                        x = CSng(Me.Width - 200) : y = CSng(cy + 20) : x1 = CSng(Me.Width - 100) : y1 = CSng(cy + 20)
                        g.DrawLine(myPen, x, y, x1, y1)
                        If iretB <> 0 Then
                            ' dessin crochet gauche 
                            x = CSng(Me.Width - 200 - 3) : y = CSng(cy + 14)
                            x1 = 6 : y1 = 6
                            startAngle = 90 : sweepAngle = 135
                            g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                            x = CSng(Me.Width - 200 - 3 - 3 * Cos(3 * PI / 4)) : y = CSng(cy + 14 + 3 - 3 * Sin(PI / 4))
                            x1 = x + CSng(6 * 0.707) : y1 = y - CSng(6 * 0.707)
                            g.DrawLine(myPen, x, y, x1, y1)
                            'dessin crochet droit armature transversale semelle
                            x = CSng(Me.Width - 100 - 3) : y = CSng(cy + 14)
                            x1 = 6 : y1 = 6
                            startAngle = 315 : sweepAngle = 135
                            g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                            x = CSng(Me.Width - 100 - 3 + 6 * Cos(PI / 4)) : y = CSng(cy + 14 + 3 - 6 * Sin(3 * PI / 4))
                            x1 = x - CSng(6 * 0.707) : y1 = y - CSng(6 * 0.707)
                            g.DrawLine(myPen, x, y, x1, y1)
                        End If
                        'Dessin caractristiques aciers  suivant A
                        x = CSng(Me.Width - 200) : y = CSng(cy + 120) : x1 = CSng(Me.Width - 100) : y1 = CSng(cy + 120)
                        g.DrawLine(myPen, x, y, x1, y1)
                        If iretA <> 0 Then
                            ' dessin crochet gauche 
                            x = CSng(Me.Width - 200 - 3) : y = CSng(cy + 114)
                            x1 = 6 : y1 = 6
                            startAngle = 90 : sweepAngle = 135
                            g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                            x = CSng(Me.Width - 200 - 3 - 3 * Cos(3 * PI / 4)) : y = CSng(cy + 114 + 3 - 3 * Sin(PI / 4))
                            x1 = x + CSng(6 * 0.707) : y1 = y - CSng(6 * 0.707)
                            g.DrawLine(myPen, x, y, x1, y1)
                            'dessin crochet droit armature transversale semelle
                            x = CSng(Me.Width - 100 - 3) : y = CSng(cy + 114)
                            x1 = 6 : y1 = 6
                            startAngle = 315 : sweepAngle = 135
                            g.DrawArc(myPen, x, y, x1, y1, startAngle, sweepAngle)
                            x = CSng(Me.Width - 100 - 3 + 6 * Cos(PI / 4)) : y = CSng(cy + 114 + 3 - 6 * Sin(3 * PI / 4))
                            x1 = x - CSng(6 * 0.707) : y1 = y - CSng(6 * 0.707)
                            g.DrawLine(myPen, x, y, x1, y1)
                        End If
                        'Ecriture longueur acier longitudinaux
                        F_la = Format(la * 100, "###") 'en cm
                        msg = F_la
                        w = g.MeasureString(msg, myFont)
                        x = CSng(Me.Width - 150 - w.Width / 2) : y = CSng(cy + 126)
                        g.DrawString(msg, myFont, myBrush, x, y)
                        'Ecriture longueur acier transversaux
                        If geom = 1 Then
                            F_lb = Format(lb * 100, "###") 'en cm
                            msg = F_lb
                        Else
                            msg = "acier filant"
                        End If
                        w = g.MeasureString(msg, myFont)
                        x = CSng(Me.Width - 150 - w.Width / 2) : y = CSng(cy + 14 - w.Height)
                        g.DrawString(msg, myFont, myBrush, x, y)
                        If iretB <> 0 Then
                            'Ecriture crochet acier infrieur
                            F_iretB = Format(iretB * 100, "###") 'en cm
                            msg = F_iretB
                            w = g.MeasureString(msg, myFont)
                            x = CSng(Me.Width - 200 - w.Width) : y = CSng(cy + 14 - w.Height)
                            g.DrawString(msg, myFont, myBrush, x, y)
                        End If
                        If iretA <> 0 Then
                            'Ecriture crochet acier suprieur
                            F_iretA = Format(iretA * 100, "###") ' en cm
                            msg = F_iretA
                            w = g.MeasureString(msg, myFont)
                            x = CSng(Me.Width - 200 - w.Width) : y = CSng(cy + 120 - w.Height)
                            g.DrawString(msg, myFont, myBrush, x, y)
                        End If
                End Select

                'Case 3
                'Call Dessin_semel_filante()
        End Select

        '        myPen.DashStyle = Drawing.Drawing2D.DashStyle.DashDotDot
        '        myPen.DashOffset = 25
        '        x = CSng(10) : y = CSng(cy - hh - hhpl - lld - 10) : x1 = CSng(cx + aa + 200) : y1 = CSng(cy - hh - hhpl - lld - 10)
        '        g.DrawLine(myPen, x, y, x1, y1)
        '        myPen = New Pen(Color.Black, 2)
        '        myPen.DashStyle = Drawing.Drawing2D.DashStyle.Solid

        '    x = CSng(orix - 30) : y = CSng(oriy + eenr + espb) : x1 = -20 : y1 = 20
        '    g.DrawEllipse(myPen, x, y, x1, y1)
        'End If
    End Sub

    Private Sub Reduction_dim_geometrique(ByVal red As Double, ByRef aa As Double, ByRef ppa As Double, _
    ByRef hh As Double, ByRef eenr As Double, ByRef llcsup As Double, ByRef llcinf As Double, ByRef llc1 As Double, _
    ByRef rmphia As Double, ByRef llc2 As Double, ByRef ilbb As Double)
        aa = a * 1000 / 20 ' rduction longueur a en mm et au 1/20
        aa = aa * red   'rduction des valeurs en twips
        hh = h * 1000 / 20 ' rduction longueur h en mm et au 1/20
        hh = hh * red
        If geom = 1 Then
            ppa = pa * 1000 / 20 ' rduction longueur pa en mm et au 1/20
        Else
            ppa = Lvoile * 1000 / 20 ' rduction longueur pa en mm et au 1/20
        End If
        ppa = ppa * red
        llcsup = lcsup * 1000 / 20 ' rduction longueur lcsup en mm et au 1/20
        llcsup = llcsup * red
        llcinf = lcinf * 1000 / 20 ' rduction longueur lcinf en mm et au 1/20
        llcinf = llcinf * red
        llc2 = lc2 * 1000 / 20 ' rduction longueur lc2 en mm et au 1/20
        llc2 = llc2 * red
        llc1 = lc1 * 1000 / 20 ' rduction longueur lc1 en mm et au 1/20
        llc1 = llc1 * red
        eenr = (enr + 0.01) * 1000 / 20 ' rduction longueur d17 en mm et au 1/20
        eenr = eenr * red
        ilbb = ilB * 1000 / 20 ' rduction longueur lc1 en mm et au 1/20
        ilbb = ilbb * red
        rmphia = rm * phiA * 1000 / 20 ' rduction longueur rm x phiA en mm et au 1/20
        rmphia = rmphia * red
    End Sub

End Class
