Imports System.Math
Module Calcul
    Dim aext, Adets(11), ar, asa(4), asah(4), Asb(4), asbh(4) As Double ', at!, ata!(4), atb(4) As Single
    Dim b8, br, calc(2, 4), d17, d As Double
    Dim fb, fs, ft, hld(5) As Double
    Dim p1, phi As Double
    Dim tau(4), ts As Double
    Dim X, xa(4), xb(4), xlam As Double
    Dim nbar As Integer
    Dim title As String = "Semelle superficielle BA : module de calcul"
    Public Sub ddio()
        'diam^tre des barres HA
        Dim i As Integer
        For i = 1 To 6 : dio(i) = 0.006 + 0.002 * (i - 1) : Next i
        dio(7) = 0.02 : dio(8) = 0.025 : dio(9) = 0.032 : dio(10) = 0.04
    End Sub
    Private Sub Arret_barre(ByVal l As Double, ByVal phi As Double, ByVal ac As Double, ByVal cote As Integer, _
        ByVal N_comb As Integer, ByVal ex() As Double)
        Dim nu, k, la, laa, laaa, ls, u1, phi1, XX, m, Vu1 As Double
        Dim j As Integer
        Dim d1, tauS, tauSU As Double
        Dim diametre_long() As Single = {5.5, 6, 7, 6, 7, 9, 8, 9, 7, 7, 9}
        Dim espacement_longitudinal() As Integer = {200, 150, 150, 100, 100, 150, 100, 100, 150, 100, 100}
        Dim diametre_trans() As Single = {5.5, 7, 7, 7, 7, 8, 8, 8, 7, 7, 9}
        Dim espacement_transversal() As Integer = {200, 300, 300, 300, 300, 300, 300, 200, 150, 100, 100}
        Select Case geom
            Case 1 'semelle isole
                Select Case Type_acier
                    Case 1  'TS
                        ' rdig suivant l'article 4.2,3 du document ADETS "Treillis souds - calcul et utilisation" de PERCHAT
                        Select Case calcc(cote)  '1
                            Case 1  'dtermination de l'acier par la mthode des bielles
                                Select Case nbLit
                                    Case 1 '1 lit    
                                        Select Case cote
                                            Case 1 '//  A
                                                phi1 = diametre_long(NLit_TS(1))
                                                espmin = espacement_longitudinal(NLit_TS(1))
                                            Case Else
                                                phi1 = diametre_trans(NLit_TS(1)) ' CDbl(rs.Fields("diametre long").Value)
                                                espmin = espacement_transversal(NLit_TS(1))
                                        End Select
                                        m = 1000 / espmin
                                        k = 160 / (m * phi1)
                                    Case 2 ' 2 lits
                                        XX = 0
                                        For j = 2 To 3
                                            Select Case cote
                                                Case 1 '//  A
                                                    phi1 = diametre_long(NLit_TS(j))
                                                    espmin = espacement_longitudinal(NLit_TS(j))
                                                Case Else
                                                    phi1 = diametre_trans(NLit_TS(j))
                                                    espmin = espacement_transversal(NLit_TS(j))
                                            End Select
                                            m = 1000 / espmin
                                            XX = XX + m * phi1
                                        Next j
                                        k = 160 / XX
                                End Select
                                If calcc(1) = 1 And calcc(2) = 1 Then
                                    If cote = 1 Then  '//  A
                                        tauS = k * ac * 4 * fe / (1.15 * a)
                                    Else
                                        tauS = k * ac * 4 * fe / (1.15 * b)
                                    End If
                                    tauSU = 1.1 * ft
                                    Select Case tauS
                                        Case Is > tauSU 'barres comportent des crochets
                                            Icrochet = 1
                                        Case Is > 0.5 * tauSU 'barres ne comportent pas de crochets
                                            Icrochet = 2
                                        Case Else        'arret d'une barre sur deux ou disposer en portefeuille
                                            Icrochet = 3
                                            If nbLit = 1 Then Icrochet = 2
                                    End Select
                                Else
                                    If cote = 1 Then '//  A
                                        la = a : laa = pa : laaa = b
                                    Else
                                        la = b : laa = pb : laaa = a
                                    End If
                                    If (la - laa) / 2 <= h Then
                                        Icrochet = 1
                                    Else
                                        If d <= (1.5 * (la / 2 - 0.35 * laa)) Then d1 = d Else d1 = (1.5 * (la / 2 - 0.35 * laa))
                                        Vu1 = p(1, N_comb) * (la - 0.7 * laa) / (2 * la)
                                    End If
                                    If Vu1 <= (0.54 * laaa * d1 * ft / k) Then
                                        Icrochet = 1 'le TS comporte des crochet
                                    Else
                                        msg = "Le treillis soud ne satisfait pas la condition d'adhrence."
                                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "Semelle : module de calcul")
                                    End If
                                End If
                            Case 2 'dtermination de l'acier par la mthode du moment
                                'calcul suivant commentaires 4.3,3 fascicule ADETS Perchat
                                If cote = 1 Then
                                    la = a : laa = pa : laaa = b
                                Else
                                    la = b : laa = pb : laaa = a
                                End If
                                If (la - laa) / 2 <= h Then
                                    Icrochet = 1
                                Else
                                    If d <= (1.5 * (la / 2 - 0.35 * laa)) Then d1 = d Else d1 = (1.5 * (la / 2 - 0.35 * laa))
                                    If ex(N_comb) >= (0.5 * (la / 2 + 0.35 * laa)) Then
                                        Vu1 = p(1, N_comb)
                                    Else
                                        Vu1 = ((p(1, N_comb) / 2) * (la - 0.7 * laa) / (la - 2 * ex(N_comb)))
                                    End If
                                End If
                                Select Case nbLit
                                    Case 1 '1 lit
                                        phi1 = diametre_long(NLit_TS(1))
                                        espmin = espacement_longitudinal(NLit_TS(1))
                                        m = 1000 / espmin
                                        k = 160 / (m * phi1)
                                    Case 2 ' 2 lits
                                        XX = 0
                                        For j = 2 To 3
                                            phi1 = diametre_long(NLit_TS(j))
                                            espmin = espacement_longitudinal(NLit_TS(j))
                                            m = 1000 / espmin
                                            XX = XX + m * phi1
                                        Next j
                                        k = 160 / XX
                                End Select
                                If Vu1 <= (0.54 * laaa * d1 * ft / k) Then
                                    Icrochet = 1 'le TS comporte des crochet
                                Else
                                    msg = "Le treillis soud ne satisfait pas la condition d'adhrence."
                                    MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "Semelle : module de calcul")
                                End If
                        End Select
                    Case 2  'barres HA
                        tauS = 0.6 * 1.5 ^ 2 * ft 'diamtre minimun de l'acier pris gal 8 mm
                        ls = (phi * fe / (4 * tauS))
                        If Sism = 1 Then ls = (1.3 * ls) 'en zone sismique, augmentation de 30% de
                        'la longueur de scellement (Art 11.313)
                        If ls >= l / 4 Then
                            Icrochet = 1   'barres comportent des crochets
                        Else
                            Icrochet = 2   'barres ne comportent pas de crochets
                        End If
                End Select
            Case 2  'semelle filante
                Select Case Type_acier
                    Case 1  'TS
                        ' rdig suivant l'article 4.2,3 du document ADETS "Treillis souds - calcul et utilisation"
                        ' de PERCHAT
                        Select Case calcc(cote)  '1
                            Case 1  'dtermination de l'acier par la mthode des bielles
                                Select Case nbLit
                                    Case 1 '1 lit
                                        phi1 = diametre_long(NLit_TS(1))
                                        espmin = espacement_longitudinal(NLit_TS(1))
                                        m = 1000 / espmin
                                        k = 160 / (m * phi1)
                                    Case 2 ' 2 lits
                                        XX = 0
                                        For j = 2 To 3
                                            phi1 = diametre_long(NLit_TS(j))
                                            espmin = espacement_longitudinal(NLit_TS(j))
                                            m = 1000 / espmin
                                            XX = XX + m * phi1
                                        Next j
                                        k = 160 / XX
                                End Select
                                tauS = k * ac * 4 * fe / (1.15 * a)
                                tauSU = 1.35 * ft
                                Select Case tauS
                                    Case Is > tauSU 'barres comportent des crochets
                                        Icrochet = 1
                                    Case Is > 0.5 * tauSU 'barres ne comportent pas de crochets
                                        Icrochet = 2
                                    Case Else        'arret d'une barre sur deux ou disposer en portefeuille
                                        Icrochet = 3
                                        If nbLit = 1 Then Icrochet = 2
                                End Select
                            Case 2 'dtermination de l'acier par la mthode du moment
                                'calcul suivant commentaires 4.3,3 fascicule ADETS Perchat
                                If (a - Lvoile) / 2 <= h Then
                                    Icrochet = 1
                                    Exit Sub
                                Else
                                    If d <= (1.5 * (a / 2 - 0.35 * Lvoile)) Then d1 = d Else d1 = (1.5 * (a / 2 - 0.35 * Lvoile))
                                    If ex(N_comb) >= (0.5 * (a / 2 + 0.35 * Lvoile)) Then
                                        Vu1 = p(1, N_comb)
                                    Else
                                        Vu1 = ((p(1, N_comb) / 2) * (a - 0.7 * Lvoile) / (a - 2 * ex(N_comb)))
                                    End If
                                End If
                                Select Case nbLit
                                    Case 1 '1 lit
                                        phi1 = diametre_long(NLit_TS(1))
                                        espmin = espacement_longitudinal(NLit_TS(1))
                                        m = 1000 / espmin
                                        k = 160 / (m * phi1)
                                    Case 2 ' 2 lits
                                        XX = 0
                                        For j = 2 To 3
                                            phi1 = diametre_long(NLit_TS(j))
                                            espmin = espacement_longitudinal(NLit_TS(j))
                                            m = 1000 / espmin
                                            XX = XX + m * phi1
                                        Next j
                                        k = 160 / XX
                                End Select
                                If Vu1 <= (0.675 * d1 * ft / k) Then
                                    Icrochet = 2 'le TS ne comporte pas de crochet
                                Else
                                    Icrochet = 1 'le TS comporte des crochet
                                End If
                        End Select
                    Case 2  'barres HA
                        tauS = 0.6 * 1.5 ^ 2 * ft 'diamtre minimun de l'acier pris gal 8 mm
                        ls = (phi * fe / (4 * tauS))
                        If Sism = 1 Then ls = (1.3 * ls) 'en zone sismique, augmentation de 30% de
                        'la longueur de scellement (Art 11.313)
                        Select Case ls
                            Case Is >= l / 4 'barres comportent des crochets
                                Icrochet = 1
                            Case Is >= l / 8 'barres ne comportent pas de crochets
                                Icrochet = 2
                            Case Else        'arret d'une barre sur deux ou disposer en portefeuille
                                Icrochet = 3
                        End Select
                End Select
        End Select
    End Sub
    Public Sub Sbael(ByRef lire As Integer)
        'PROGRAMME  SEMELLE - Philippe  DEJEAN - 1999
        'Programme de Calcul des Semelles Rectangulaires - Dimensionnement,Ferraillage et Metre
        'Selon BAEL 99 et DTU 13-1
        'selon fascicule 6 de l'ADETS et tome 1 "Conception et calcul des structures de batiments"
        'de H THONIER 1992
        Dim i As Integer
        Dim eA(4), atb0st(4) As Double
        Call ddio()
        'Initialisation des donnes  0

        fb = (0.85 * fc / gamaB)
        ft = (0.06 * fc + 0.6)
        taul = (0.045 * fc / gamaB)
        fs = fe / gamaS
        d17 = (enr + 0.01) 'Enrobage a l'Axe de l'Acier en m
        If angle1 = 90 Then xlam = 15
        If angle1 = 135 Then xlam = 10
        If angle1 = 180 Then xlam = 5
        lire = 0
        'dtermination des limites de calcul des dimensions de la semelle
        Select Case geom
            Case 1  'semelle isole
                Select Case choix
                    Case 1 'ctes libres
                        aL = 15 * pa : bL = 15 * pb
                    Case 2, 3 'A limit ou impos
                        bL = 15 * pb
                End Select
            Case 2  'semelle filante
                Select Case choix
                    Case 1 'ctes libres, semelle filante --> bl=1 mtre
                        aL = 15 * Lvoile : bL = 1
                    Case 2, 3, 7 'A limit ou impos
                        bL = 1
                End Select
            Case 3 'semelle filante non arme
                Select Case choix
                    Case 1 'ctes libres, semelle filante --> bl=1 mtre
                        aL = 15 * Lvoile : bL = 1
                    Case 2, 3, 7 'A limit ou impos
                        bL = 1
                End Select
        End Select


        Call Calcul_Semel_ELU(lire, eA, atb0st)  'Calcul de la Semelle en ELU
        If lire = 1 Then Exit Sub
        Call Calcul_Semel_ELS(lire)  'Calcul de la Semelle en ELS
        If lire = 1 Then Exit Sub

        Select Case geom
            Case 1  'semelle isole
                Select Case Type_acier
                    Case 1  'TS
                        Call Ferraillage_TS(assa, a, assb, lire, nasacomb, nasbcomb, eA, eA)
                        If lire = 1 Then Exit Sub
                        Call Fiche_de_ferraillage_poteau()    'Ferraillage amorce poteau
                    Case 2  'barres HA
                        'ac = assa : a1 = a : b1 = bp(1, )
                        Call Ferraillage_HA(assa, a, b, nbarA, phiA, ilA, iretA, la, nasacomb, eA) 'Ferraillage Semelle Cote A
                        'nbarA = nbar : phiA = phi : ilA = il : iretA = iret : la = l
                        'ac = assb : a1 = b : b1 = a
                        Call Ferraillage_HA(assb, b, a, nbarB, phib, ilB, iretB, lb, nasbcomb, eA)  'Ferraillage Semelle Cote B
                        'nbarB = nbar : phib = phi : ilB = il : iretB = iret : lb = l
                        'Ferraillage Effort Tranchant
                        Dim at As Double
                        at = atb0st(1)
                        i = 1
                        Do While atb0st(i) <> 0 'recherche de l'effort max
                            If at < atb0st(i) Then at = atb0st(i)
                            i = i + 1
                            If i = 5 Then Exit Do
                        Loop
                        If at <> 0 Then
                            Call Fiche_de_ferraillage_tranchant() 'Ferraillage effort tranchant
                        End If
                        'Ferraillage en partie haute de la semelle // au ct A
                        If assah <> 0 Or at <> 0 Then
                            'ac = assah : a1 = a : b1 = b
                            Call Ferraillage_HA(assah, a, b, nbarAh, phiAh, ilAh, iretAh, lah, nasacomb, eA)  'Ferraillage haut Semelle Cote A
                            'nbarAh = nbar : phiAh = phi : ilAh = il : iretAh = iret : lah = l
                        End If
                        If assbh <> 0 Then
                            'ac = assbh : a1 = b : b1 = a
                            Call Ferraillage_HA(assbh, b, a, nbarBh, phiBh, ilBh, iretBh, lbh, nasbcomb, eA)  'Ferraillage haut Semelle Cote B
                            'nbarBh = nbar : phiBh = phi : ilBh = il : iretBh = iret : lbh = l
                        End If

                        '
                        Call Fiche_de_ferraillage_poteau()    'Ferraillage amorce poteau
                End Select
            Case 2  'semelle filante
                Select Case Type_acier
                    Case 1  'TS
                        Call Ferraillage_TS(assa, a, assb, lire, nasacomb, nasbcomb, eA, eA)
                        If lire = 1 Then Exit Sub
                        If Attente = True Then
                            If lcinf = 0 And lcsup = 0 Then
                                Call Fiche_de_ferraillage_voile() 'Ferraillage amorce voile
                            Else
                                lc2 = lcinf + lcsup
                                lc = lc2 : lc1 = 0
                            End If
                        End If
                    Case 2  'barres HA
                        Call Ferraillage_HA(assa, a, b, nbarA, phiA, ilA, iretA, la, nasacomb, eA)  'Ferraillage Semelle Cote A
                        Call Acier_repartition(assb, nbarB, phib, ilB, iretB, lb)  'Ferraillage Semelle Cote B
                        If assah <> 0 Then
                            'ac = assah : a1 = a : b1 = b
                            'Call Ferraillage_HA() 'Ferraillage haut Semelle Cote A
                            'nbarAh = nbar : phiAh = phi : ilAh = il : iretAh = iret : lah = l
                        End If
                        If assbh <> 0 Then
                            '    ac = assbh : a1 = b : b1 = a
                            '    Call Ferraillage_HA() 'Ferraillage haut Semelle Cote B
                            '    nbarBh = nbar : phiBh = phi : ilBh = il : iretBh = iret : lbh = l
                        End If
                        'If at <> 0 Then
                        '    'Call Ferraillage_HA_tranchant  'Ferraillage effort tranchant
                        'End If
                        If Voile = 1 Then Call Fiche_de_ferraillage_voile() 'Ferraillage amorce voile
                End Select
            Case 3  'semelle filante
                Select Case Type_acier
                    Case 1  'TS
                        Call Ferraillage_TS(assb, a, assb, lire, nasacomb, nasbcomb, eA, eA)
                        If lire = 1 Then Exit Sub
                    Case 2  'barres HA
                        Call Chainage_HA(assb, nbarB, phib, ilB, iretB, lb)
                End Select
                If Attente = True Then
                    If lcinf = 0 And lcsup = 0 Then
                        Call Fiche_de_ferraillage_voile() 'Ferraillage amorce voile
                    Else
                        lc2 = lcinf + lcsup
                        lc = lc2 : lc1 = 0
                    End If
                End If
                calcc(1) = 1 : calcc(2) = 1
        End Select
        If Tass = True Then Call Calcul_tassement()
        'initialisation des variables  0

        Erase asah, asbh 'valeurs de As haut suivant a et b
        Erase asa, Asb 'valeurs de As bas suivant a et b
        Erase calc
        Erase tau 'valeur du poinconnement
    End Sub
    Private Sub Calcul_Semel_ELU(ByRef lire As Integer, ByRef eA() As Double, ByRef atb0st() As Double)
        ' -----------------------------------------------------------------------------------------
        '          Calcul de la Semelle en ELU

        Dim i As Integer
        Dim S1, eb(4), uc, ald(4), bld(4) As Double
        '-> Dtermination des dimensions gomtriques de la semelle: longueur, largeur, hauteur
        For i = 1 To 4
            If p(1, i) = 0 Then Exit For
            lire = 0
            If i = 1 Then
                'dtermination des ctes de la semelle lors du premier calcul
                Select Case geom
                    Case 1  'semelle isole
                        Select Case choix
                            Case 7
                                a = aL : b = bL : h = hL
                            Case 6
                                a = aL : b = bL : h = 0
                            Case 3, 5
                                a = aL
                                b = pb + 0.2
                                h = 0
                            Case 1, 2, 4
                                a = pa + 0.2  ' voir COIN - "Ossatures des btiments"  p72
                                b = pb + 0.2
                                h = 0
                        End Select
                    Case 2  'semelle filante arme
                        Select Case choix
                            Case 1, 2  'cte a libre ou limite, b=1m
                                a = Lvoile + 0.2 : b = 1 : h = 0
                            Case 3     'cte a impose, b=1m
                                a = aL : b = 1 : h = 0
                            Case 7     'ctes a et h imposes, b=1m
                                a = aL : b = 1 : h = hL
                        End Select
                    Case 3  'semelle filante non arme
                        Select Case choix
                            Case 1, 2  'cte a libre ou limite, b=1m
                                a = Lvoile + 0.2 : b = 1 : h = 0
                            Case 3     'cte a impose, b=1m
                                a = Lvoile : b = 1 : h = 0
                            Case 7     'ctes a et h imposes, b=1m
                                a = aL : b = 1 : h = hL
                        End Select
                End Select
            Else
                a = ald(i - 1) : b = bld(i - 1)
                If choix = 7 Then h = hld(i)
            End If

            Call Calc_Hauteur_Semel(lire)
            If lire = 1 Then Exit Sub
            If Abs(mty(1, i) + hf * Hx(1, i)) > 0 Or Abs(mx(1, i) + hf * Hy(1, i)) > 0 Then
                Call Calc_A_B_avec_moment(lire, i, eA, eb) 'Avec Moment(s)
            Else
                Call Calc_A_B_sans_moment(lire, i, eA, eb) 'Sans Moment sachant que ea et eb nuls
            End If
            If lire = 1 Then
                msg = "Les limites ou dimension(s) Impose(s)  la semelle" & vbCrLf & _
                        "sont insuffisante(s) . La contrainte au sol n'est pas" & vbCrLf & _
                        "respecte . Modifiez les limites ou dimensions de la" & vbCrLf & _
                        "semelle ou changez la profondeur d'implantation !" & vbCrLf & _
                        "Cliquez sur la touche OK"
                MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                Exit Sub
            End If

            ald(i) = a : bld(i) = b
            If choix = 7 Then hld(i) = h

            'vrification au poinonnement
            Select Case geom
                Case 1  'semelle isole
                    Do
                        aext = (a * b) - (PI * (5 * h / 6) ^ 2 + pa * pb + 2 * pb * (5 * h / 6) + 2 * pa * (5 * h / 6))
                        uc = 2 * (pa + pb) + PI * h
                        p1 = p(1, i) * (aext / (a * b))
                        tau(i) = p1 / (uc * h)
                        h = h + 0.01
                    Loop Until tau(i) <= tol1 * taul
                    h = h - 0.01
                    If choix = 7 Then
                        If h > hL Then
                            msg = "Hauteur de la semelle insuffisante pour satisfaire" & vbCrLf & _
                                              "la condition au poinonnement !" & vbCrLf & _
                                              "Cliquez sur la touche Retour"
                            MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                            Exit Sub
                        End If
                    End If
                Case 2  'semelle filante
                    Do
                        tau(i) = (p(1, i) / (2 * h)) * (1 - (Lvoile + (5 * h / 3)) / a) 'Thonier equation 7 p226 T1
                        h = h + 0.01
                    Loop Until tau(i) <= tol1 * taul
                    h = h - 0.01
                    If choix = 7 Then
                        If h > hL Then
                            msg = "Hauteur de la semelle insuffisante pour satisfaire" & vbCrLf & _
                                              "la condition au poinonnement !" & vbCrLf & _
                                              "Cliquez sur la touche OK"
                            MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                            lire = 1
                            Exit Sub
                        End If
                    End If
            End Select
        Next i
        '-> Dtermination du ferraillage
        smax = 0 : nsmax = 1
        For i = 1 To 4 'indice des combinaisons ELU
            If p(1, i) = 0 Then Exit For
            Call Contrainte_Sol_ELU(i, S1, eA, eb) 'Contraintes du Sol ELU
            If smax < S1 Then smax = S1 : nsmax = i 'contrainte sol maxi et n de combinaison
            Call Ferraillage_ELU(lire, i, eA, eb, S1, atb0st) 'Ferraillage ELU
        Next i
        a = ald(1) : b = bld(1) : assa = asa(1) : assb = Asb(1) : taumax = tau(1)
        nacomb = 1 : nbcomb = 1 : nasacomb = 1 : nasbcomb = 1 : calcc(1) = calc(1, 1) : calcc(2) = calc(2, 1)
        assah = asah(1) : assbh = asbh(1) : nasahcomb = 1 : nasbhcomb = 1 : ntaumax = 1
        For i = 1 To 3   ' recherche des combinaisons  dfavorables
            If a < ald(i + 1) Then a = ald(i + 1) : nacomb = i + 1 'recherche du n de combinaison
            If b < bld(i + 1) Then b = bld(i + 1) : nbcomb = i + 1 'dimensionnant a et b
            If assa < asa(i + 1) Then assa = asa(i + 1) : nasacomb = i + 1 : calcc(1) = calc(1, i + 1) '
            If assb < Asb(i + 1) Then assb = Asb(i + 1) : nasbcomb = i + 1 : calcc(2) = calc(2, i + 1)
            If assah < asah(i + 1) Then assah = asah(i + 1) : nasahcomb = i + 1 '
            If assbh < asbh(i + 1) Then assbh = asbh(i + 1) : nasbhcomb = i + 1
            If taumax < tau(i + 1) Then taumax = tau(i + 1) : ntaumax = i + 1
        Next i
        Erase eb
        Erase ald, bld 'valeurs de a et b
    End Sub
    Private Sub Ferraillage_ELU(ByRef lire As Integer, ByVal N_comb As Integer, ByVal ea() As Double, ByVal eb() As Double, _
                                ByVal S1 As Double, ByRef atb0st() As Double)
        ' Ferraillage ELU de la semelle
        Dim asb1, ms1h, force, force1 As Double
        Select Case geom
            Case 1  'semelle isole

                If ea(N_comb) = 0 And eb(N_comb) = 0 Then     ' calcul suivant la mthode des bielles
                    asa(N_comb) = (p(1, N_comb) * (a - pa)) / (8 * d * fs)
                    Asb(N_comb) = (p(1, N_comb) * (b - pb)) / (8 * d * fs)
                    calc(1, N_comb) = 1 : calc(2, N_comb) = 1
                    Exit Sub
                End If
                If ea(N_comb) = 0 Then    'calcul suivant mthode des poutres - voir fascicule ADETS
                    calc(1, N_comb) = 1 : calc(2, N_comb) = 2
                    If eb(N_comb) <= 0.5 * (b / 2 + 0.35 * pb) Then
                        ms1(N_comb) = ((b / 2 - 0.35 * pb) ^ 2) * p(1, N_comb) / (2 * (b - 2 * eb(N_comb)))
                    Else
                        ms1(N_comb) = p(1, N_comb) * (eb(N_comb) - 0.35 * pb)
                    End If
                    Call Calcul_Poutre_BA(ms1(N_comb), a, Asb(N_comb))
                    Select Case fe  'condition de chainage du DTU
                        Case 400  'fe400
                            asb1 = 2 / 10000 'cm-->m
                        Case 500  'fe500
                            asb1 = 1.6 / 10000 'cm-->m
                    End Select
                    If Asb(N_comb) < asb1 Then Asb(N_comb) = asb1
                    asa(N_comb) = (p(1, N_comb) * (a - pa)) / (8 * d * fs)
                    If asa(N_comb) < asb1 Then asa(N_comb) = asb1
                    If asa(N_comb) < Asb(N_comb) / 5 Then asa(N_comb) = Asb(N_comb) / 5 'commentaire 4.5,2 Perchat fascicule ADETS
                    Call Verification_Effort_Tranchant(b, pb, eb, pa, lire, N_comb, atb0st)
                    'atb(N_comb) = at: ata(N_comb) = 0
                    If Ferraillage_haut = True And eb(N_comb) > b / 6 Then
                        X = 3 * (b / 2 - eb(N_comb))
                        force = ((b - X) * 1.35 * (a * h * dsb + dss * a * (hf - h)))
                        ms1h = force * (b / 2 - 0.35 * pb - (b - X) / 2)
                        Call Calcul_Poutre_BA(ms1h, a, asbh(N_comb))
                    Else
                        asbh(N_comb) = 0 : asah(N_comb) = 0
                    End If

                Else
                    calc(1, N_comb) = 2 : calc(2, N_comb) = 1
                    If ea(N_comb) <= 0.5 * (a / 2 + 0.35 * pa) Then
                        ms1(N_comb) = ((a / 2 - 0.35 * pa) ^ 2) * p(1, N_comb) / (2 * (a - 2 * ea(N_comb)))
                    Else
                        ms1(N_comb) = p(1, N_comb) * (ea(N_comb) - 0.35 * pa)
                    End If
                    Call Calcul_Poutre_BA(ms1(N_comb), b, asa(N_comb))
                    Select Case fe  'condition de chainage du DTU
                        Case 400  'fe400
                            asb1 = 2 / 10000 'cm-->m
                        Case 500  'fe500
                            asb1 = 1.6 / 10000 'cm-->m
                    End Select
                    If asa(N_comb) < asb1 Then asa(N_comb) = asb1
                    Asb(N_comb) = (p(1, N_comb) * (b - pb)) / (8 * d * fs)
                    If Asb(N_comb) < asb1 Then Asb(N_comb) = asb1
                    If Asb(N_comb) < asa(N_comb) / 5 Then Asb(N_comb) = asa(N_comb) / 5 'commentaire 4.5,2 Perchat fascicule ADETS
                    Call Verification_Effort_Tranchant(a, pa, ea, pb, lire, N_comb, atb0st)
                    'ata(N_comb) = at: atb(N_comb) = 0
                    If Ferraillage_haut = True And ea(N_comb) > a / 6 Then
                        X = 3 * (a / 2 - ea(N_comb))
                        force = ((a - X) * 1.35 * (b * h * dsb + dss * b * (hf - h)))
                        ms1h = force * (a / 2 - 0.35 * pa - (a - X) / 2)
                        sigma_beton = ms1h / (b * h ^ 2 / 6)
                        Call Calcul_Poutre_BA(ms1h, b, asbh(N_comb)) ' moment, longueur semelle
                    Else
                        If ea(N_comb) > a / 6 Then
                            X = 3 * (a / 2 - ea(N_comb))
                            force = ((a - X) * 1.35 * (b * h * dsb + dss * b * (hf - h)))
                            ms1h = force * (a / 2 - 0.35 * pa - (a - X) / 2)
                            sigma_beton = ms1h / (b * h ^ 2 / 6)
                        End If
                        asbh(N_comb) = 0 : asah(N_comb) = 0
                    End If

                End If
            Case 2  'semelle filante avec voile
                If ea(N_comb) = 0 And eb(N_comb) = 0 Then      ' calcul suivant la mthode des bielles
                    asa(N_comb) = (p(1, N_comb) * (a - Lvoile)) / (8 * d * fs)
                    Asb(N_comb) = (asa(N_comb) / 5) * a  'suivant Perchat et Roux
                    Select Case fe  'condition de chainage du DTU complt par les commentaires
                        Case 400  'fe400                                        de Perchat et Roux
                            asb1 = 2 / 10000  'cm-->m
                        Case 500  'fe500
                            asb1 = 1.6 / 10000  'cm-->m
                    End Select
                    If Asb(N_comb) < asb1 Then Asb(N_comb) = asb1
                    calc(1, N_comb) = 1 : calc(2, N_comb) = 1

                Else  'calcul suivant mthode des poutres - voir fascicule ADETS
                    calc(1, N_comb) = 2 : calc(2, N_comb) = 1
                    If ea(N_comb) <= 0.5 * (a / 2 + 0.35 * Lvoile) Then
                        ms1(N_comb) = ((a / 2 - 0.35 * Lvoile) ^ 2) * p(1, N_comb) / (2 * (a - 2 * ea(N_comb)))
                    Else
                        ms1(N_comb) = p(1, N_comb) * (ea(N_comb) - 0.35 * Lvoile)
                    End If
                    Call Calcul_Poutre_BA(ms1(N_comb), 1, asa(N_comb)) ' moment, longueur semelle
                    Asb(N_comb) = (asa(N_comb) / 5) * a 'suivant commentaires 4.3,4 fascicule ADETS Perchat
                    Select Case fe  'condition de chainage du DTU
                        Case 400  'fe400
                            asb1 = 2 / 10000 'cm-->m
                        Case 500  'fe500
                            asb1 = 1.6 / 10000 'cm-->m
                    End Select
                    If Asb(N_comb) < asb1 Then Asb(N_comb) = asb1
                    Call Verification_Effort_Tranchant(a, Lvoile, ea, 1, lire, N_comb, atb0st)
                    'ata(N_comb) = at: atb(N_comb) = 0
                    If Ferraillage_haut = True And ea(N_comb) > a / 6 Then
                        X = a - 2 * ea(N_comb) : force1 = 0 'art 1.6 p211 T1 Thonier
                        If X > (a + Lvoile) / 2 Then force1 = S1 * (X - (a + Lvoile) / 2) 'reaction sur la semelle
                        force = ((a - Lvoile) * 1.35 * (b * h * dsb + dss * b * (hf - h))) / 2
                        ms1h = force * (a / 4 + 0.15 * Lvoile) - force1 * (X / 2 - 0.25 * a - 0.1 * Lvoile) 'dcalage du moment
                        sigma_beton = ms1h / (h ^ 2 / 6) 'contrainte de traction sur le bton en section
                        Call Calcul_Poutre_BA(ms1h, 1, asah(N_comb)) ' moment, longueur semelle        'rendu homogne
                    Else
                        If ea(N_comb) > a / 6 Then 'art 1.6 p211 T1 Thonier
                            X = a - 2 * ea(N_comb) : force1 = 0 'art 1.6 p211 T1 Thonier
                            If X > (a + Lvoile) / 2 Then force1 = S1 * (X - (a + Lvoile) / 2) 'reaction sur la semelle
                            force = ((a - Lvoile) * 1.35 * (b * h * dsb + dss * b * (hf - h))) / 2
                            ms1h = force * (a / 4 + 0.15 * Lvoile) - force1 * (X / 2 - 0.25 * a - 0.1 * Lvoile) 'dcalage du moment
                            sigma_beton = ms1h / (h ^ 2 / 6) 'contrainte de traction sur le bton en section
                        Else
                            sigma_beton = 0
                        End If
                        asbh(N_comb) = 0 : asah(N_comb) = 0
                    End If

                End If
            Case 3  'semelle filante non arme
                sigma_beton = 0
                Select Case fe  'condition de chainage du DTU  complt par les commentaires
                    Case 400  'fe400                                         de Perchat et Roux
                        Asb(N_comb) = 2 / 10000 'cm-->m
                    Case 500  'fe500
                        Asb(N_comb) = 1.6 / 10000  'cm-->m
                End Select
                asa(N_comb) = 0
        End Select
    End Sub
    Private Sub Calcul_Poutre_BA(ByVal m As Double, ByVal la As Double, ByRef sa As Double)
        'calcul de la section d'acier suivant la thorie des poutres BA en flexion simple
        Dim u, zz As Double
        u = m / (la * fb * d ^ 2)
        zz = 1.25 * (1 - Sqrt(1 - 2 * u))
        sa = m / ((1 - (0.4 * zz)) * d * fs)
    End Sub
    Private Sub Verification_Effort_Tranchant(ByVal la As Double, ByVal laa As Double, ByVal Ex() As Double, _
                                          ByVal laaa As Double, ByRef lire As Integer, ByVal N_comb As Integer, _
                                          ByRef atb0st() As Double)
        REM --------------------------------------------------------------------------------------
        REM                          vrification effort tranchant
        REM --------------------------------------------------------------------------------------
        Dim msg$
        Dim reponse As Integer
        'suivant commentaires 4.3,6 et 4.5,5 fascicule ADETS Perchat et Maitrise du BAEl p126
        If Ex(N_comb) >= 0.25 * (la + laa + d) Then
            Vu = p(1, N_comb)
        Else
            Vu = p(1, N_comb) * (la - laa - d) / (2 * (la - 2 * Ex(N_comb)))
        End If
        If geom = 2 Then
            vulim = 0.2 * d * fc / (gamaB * 2)
        Else
            vulim = 0.2 * (laaa + d) * d * fc / (gamaB * 2)
        End If
        If Vu < vulim Then
            atb0st(N_comb) = 0 'pas d'acier d'effort tranchant necessaire
        Else
            msg = "Ncessit d'acier d'effort tranchant dans la semelle." & vbCrLf & _
                "Voulez-vous continuer le calcul (Oui/Non)?"
            reponse = MsgBox(msg, MsgBoxStyle.YesNo Or MsgBoxStyle.Information, "Semelle : module de calcul")
            If reponse = vbNo Then lire = 1 : Exit Sub
            atb0st(N_comb) = vulim * gamaS / (fe * d)
        End If

    End Sub
    Private Sub Calcul_Semel_ELS(ByRef lire As Integer)
        REM ----------------------- ----- - ------------------------------------------------
        REM                            Verification ELS
        REM ---------------------------------------------------------------------------------
        Dim i As Integer
        For i = 1 To 4
            If p(2, i) = 0 Then Exit For
            Call Contrainte_Sol_ELS(i, lire) ' Contraintes en ELS
        Next i
        If fis = 2 Then
            assa = 1.1 * assa
            assb = 1.1 * assb
            assah = 1.1 * assah
            assbh = 1.1 * assbh
        End If
        If fis = 3 Then
            assa = 1.5 * assa
            assb = 1.5 * assb
            assah = 1.5 * assah
            assbh = 1.5 * assbh
        End If
    End Sub
    Private Sub Ferraillage_HA(ByVal ac As Double, ByVal A1 As Double, ByVal b1 As Double, ByRef nbar As Integer, _
                            ByRef phi As Double, ByRef il As Double, ByRef iret As Double, ByRef l As Double, _
        ByVal N_comb As Integer, ByVal eA() As Double)
        'n1 = nbre minimun de barre sur une largeur de 
        'n2 = nbre Maximun de barre sur une largeur de 
        Dim i1, i2, ip2, n1, n2 As Integer
        Dim u1, u2, ama As Double
        Dim F_ac, F_dio, F_n2, F_u2 As String
        '    Calcul des Aciers Semelle: Phi, Longueur, Crochet(PHImm,ILB,IRET),espacement
        Select Case fis
            Case 1
                If espMax > 0.33 Then espMax = 0.33
            Case 2
                If espMax > 0.25 Then espMax = 0.25
            Case 3
                If espMax > 0.2 Then espMax = 0.2
        End Select
        n1 = CInt(Int(b1 / espMax)) : n2 = CInt(Int(b1 / espmin))
        xlam = 6
        If ac > 0.01 Then ip2 = 10 Else ip2 = 8
        ama = 0.1   '1000 cm
        'recherche de la combinaison des diamtres d'acier la plus proche de la section calcule
        For i1 = n1 To n2
            i2 = 1
            Do
                i2 = i2 + 1
                u1 = i1 * PI * dio(i2) ^ 2 / 4
                If i2 > ip2 Then Exit Do
            Loop While u1 < ac
            If u1 < ama Then ama = u1 : nbar = i1 : phi = dio(i2)
        Next i1

        If ama = 0.1 Then
            u2 = n2 * dio(ip2) ^ 2 / 4 * PI
            F_ac = Format(ac * 10000, "#0.00") : F_dio = Format(dio(ip2) * 1000, "#0")
            F_n2 = Format(n2, "#0") : F_u2 = Format(u2 * 10000, "#0.00")
            msg = "Section" & F_ac & "cm2 Impossible  satisfaire" & vbCrLf & _
                              "avec " & F_n2 & " Barres de " & F_dio & " mm ( " & F_u2 & " cm2)" & _
                              vbCrLf & "Cliquez sur la touche OK"
            MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
            Exit Sub
        End If

        Call Arret_barre(A1, phi, 0, 1, N_comb, eA)
        If Icrochet >= 2 Then     '   pas de crochets, par souci de simplification de ferraillage,
            il = A1 - 2 * enr     ' on ne prend pas en compte la posiibilit d'un ferraillage en
            iret = 0              ' portefeuille
        Else               '   crochets obligatoires
            u1 = A1 - 2 * enr - 2 * (rm + 1) * phi + (angle1 * PI / 180 * (rm + 0.5) * phi) * 2 + xlam * phi * 2
            il = Int(u1 * 100 + 1) / 100
            iret = xlam * phi  ' A.6.1,255
            iret = Int(iret * 100 + 0.5) / 100
        End If
        If phib > 0 Then
            ar = a - 2 * (enr + phiA) - (phi)
            espb = ar / (nbar - 1)
            espb = Fix(espb * 1000) / 1000 'arrondi au mm infrieur
        Else
            If geom = 1 Then br = b - 2 * enr - phi Else br = 1 - 2 * enr - phi
            espa = br / (nbar - 1)
            espa = Fix(espa * 1000) / 1000 ' arrondi au mm infrieur
        End If
        l = A1 - 2 * enr
    End Sub
    Private Sub Acier_repartition(ByVal ac As Double, ByRef nbar As Integer, _
                                  ByRef phi As Double, ByRef il As Double, ByRef iret As Double, ByRef l As Double)
        Dim u1 As Double
        Dim ip2%, i2%, n1%
        '  calcul des aciers de rpartition dans la semelle
        n1 = CInt(Int(a / espMax) + 1)

        If ac > 0.01 Then ip2 = 10 Else ip2 = 8

        'recherche de la combinaison des diamtres d'acier la plus proche de la section calcule
        i2 = 1
        Do
            i2 = i2 + 1
            u1 = n1 * PI * dio(i2) ^ 2 / 4
        Loop While u1 < ac
        nbar = n1 : phi = dio(i2)
        il = 1000 : l = 1000
        iret = 0
        ar = a - 2 * (enr + phiA) - (phi)
        espb = ar / (nbar - 1)
        espb = Fix(espb * 1000) / 1000 'arrondi au mm infrieur
    End Sub

    Private Sub Fiche_de_ferraillage_tranchant()

    End Sub
    Private Sub Fiche_de_ferraillage_poteau()
        REM -----------------------------------------------------------------------------
        REM           fiche de ferraillage du poteau
        REM -----------------------------------------------------------------------------
        Dim i As Integer
        moment = 0
        For i = 1 To 4
            If p(1, i) = 0 Then Exit For
            If Abs(mty(1, i) + hf * Hx(1, i)) > 0 Or Abs(mx(1, i) + hf * Hy(1, i)) > 0 Then moment = 1
        Next i
        If moment = 1 Then
            lc1 = (35 * Ha)  'cote en m
            ts = 0.6 * 1.5 ^ 2 * ft
            lcsup = (Ha * fe) / (4 * ts)
            lcinf = h - enr - phiA - phib
        Else
            lc1 = 0
            lcsup = (Ha * fe / (9 * ft))
            lcinf = 20 * Ha
            If lcinf > h - enr - phiA - phib Then
                lcinf = h - enr - phiA - phib
                lc1 = 20 * Ha
            End If
        End If
        lc2 = lcinf + lcsup   ' cote en m
        lc2 = Int(lc2 * 100 + 0.9) / 100 'cote en m
        lc = lc1 + lc2
        nbha = nbag * nbap

    End Sub
    Private Sub Fiche_de_ferraillage_voile()
        ' amorce du ferraillage du voile
        Dim i As Integer
        moment = 0
        For i = 1 To 4
            If p(1, i) = 0 Then Exit For
            If Abs(mty(1, i) + hf * Hx(1, i)) > 0 Or Abs(mx(1, i) + hf * Hy(1, i)) > 0 Then moment = 1
        Next i
        If moment = 1 Then
            lc1 = (35 * HAvoile)  'cote en m
            ts = 0.6 * 1.5 ^ 2 * ft
            lcsup = (HAvoile * fe) / (4 * ts)
            lcinf = h - enr - phiA - phib
        Else
            lc1 = 0
            lcsup = (HAvoile * fe / (9 * ft))
            lcinf = 20 * HAvoile
            If lcinf > h - enr - phiA - phib Then
                lcinf = h - enr - phiA - phib
                lc1 = 20 * HAvoile
            End If
        End If
        lcinf = Int(lcinf * 100 + 0.9) / 100 'cote en m
        lcsup = Int(lcsup * 100 + 0.9) / 100 'cote en m
        lc2 = lcinf + lcsup   ' cote en m
        lc1 = Int(lc1 * 100 + 0.9) / 100 'cote en m
        lc = lc1 + lc2

    End Sub
    Private Sub message_soulevement(ByVal N_comb As Integer, ByVal ls As Double)
        Dim F_ls, F_i As String
        F_ls = Format(ls, "#0.000")
        F_i = Format(N_comb, "#0")
        msg = "La semelle est partiellement Souleve sur:" & vbCrLf & _
                          F_ls & " m" & vbCrLf & _
                          "Ce qui excede la valeur rglementaire en combinaison" & vbCrLf & _
                          "rare . Combinaison ELS n: " & F_i & vbCrLf & _
                          "Cliquez sur la touche Retour"
        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, title)
    End Sub
    Private Sub Calc_Hauteur_Semel(ByRef lire As Integer)
        '  Calcul des Hauteurs de la Semelle
        Dim u1, u2 As Double
        Select Case geom
            Case 1 'semelle isole
                If choix = 7 Then
                    u1 = (a - pa) / 4    ' calcul hauteur suivant A
                    u2 = (b - pb) / 4     ' calcul hauteur suivant B
                    If u1 > u2 Then u2 = u1 ' galisation
                    If h < u2 Then
                        msg = "La hauteur de la semelle est insuffisante pour considrer cette dernire" & vbCrLf & _
                                "comme rigide. Les hypothses de rpartition des contraintes sous semelle" & vbCrLf & _
                                "ne sont plus respectes (thorie de Meyerhoff)." & vbCrLf & _
                                "Nous avons affaire  une semelle souple qui sort du cadre de calcul de ce" & vbCrLf & _
                                "logiciel. Dsol !!!"
                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                        lire = 1
                        Exit Sub
                    Else
                        d = h - d17
                    End If
                Else
                    u1 = (a - pa) / 4    ' calcul hauteur suivant A
                    h = (b - pb) / 4    ' calcul hauteur suivant B
                    If u1 > h Then h = u1 ' galisation
                    h = Int(h * 100 + 0.6) / 100    ' arrondi au cm suprieur
                    d = h - d17
                End If
            Case 2  'semelle filante
                If choix = 7 Then
                    u1 = (a - Lvoile) / 4   ' calcul hauteur suivant A
                    u2 = a - Lvoile
                    If h > u2 Then
                        msg = "La hauteur de la semelle est trop importante." & vbCrLf & _
                            "Rduisez l !!!"
                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                        lire = 1
                        Exit Sub
                    End If
                    If h < u1 Then
                        msg = "La hauteur de la semelle est insuffisante pour considrer cette dernire" & vbCrLf & _
                              "comme rigide. Les hypothses de rpartition des contraintes sous semelle" & vbCrLf & _
                              "ne sont plus respectes (thorie de Meyerhoff)." & vbCrLf & _
                              "Nous avons affaire  une semelle souple qui sort du cadre de calcul de ce" & vbCrLf & _
                              "logiciel. Dsol !!!"
                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                        lire = 1
                        Exit Sub
                    Else
                        d = h - d17
                    End If
                Else
                    h = (a - Lvoile) / 4 + d17   ' calcul hauteur suivant A
                    h = Int(h * 100 + 0.6) / 100    ' arrondi au cm suprieur
                    d = h - d17
                End If
            Case 3  'semelle filante non arme
                If choix = 7 Then
                    u1 = (a - Lvoile)    ' calcul hauteur suivant A
                    If h < u1 Then
                        msg = "La hauteur de semelle est insuffisante pour justifier" & vbCrLf _
                            & "l'absence d'armatures. Modifiez la hauteur."
                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "SEMELLE : module de calcul")
                        lire = 1
                        Exit Sub
                    End If
                Else
                    h = (a - Lvoile)    ' calcul hauteur suivant A
                    h = Int(h * 100 + 0.6) / 100    ' arrondi au cm suprieur
                    d = h - d17
                End If
        End Select
    End Sub
    Private Sub Contrainte_Sol_ELU(ByVal N_comb As Integer, ByRef S1 As Double, ByRef ea() As Double, ByRef eb() As Double)
        REM --------------------------------------------------------------------------------------
        REM Calcul des Contraintes du Sol en ELU
        Dim P0 As Double
        Dim msg As String
        Call Poids_Beton_Sol(P0) 'Poids de la Semelle et de Ia Terre
        'calcul des excentricits
        ea(N_comb) = Abs((mty(1, N_comb) + hf * Hx(1, N_comb)) / p(1, N_comb)) 'calcul de l'excentricit de la charge // a
        Select Case geom
            Case 1 'semelle isole
                eb(N_comb) = Abs(mx(1, N_comb) + hf * Hy(1, N_comb) / p(1, N_comb))
                Select Case ea(N_comb)  'excentricit suivant le ct a
                    Case 0 'pas d'excentricit suivant le ct a
                        Select Case eb(N_comb) 'excentricit suivant le ct b
                            Case 0 'pas d'excentricit suivant le ct b
                                S1 = (P0 * ELU + p(1, N_comb)) / (a * b)
                            Case Is >= b / 2 ' rsultante au dela de la semelle
                                S1 = 100
                            Case Else
                                S1 = (p(1, N_comb) + P0 * ELU) / (a * (b - 2 * eb(N_comb)))
                        End Select
                    Case Is >= a / 2 ' rsultante au dela de la semelle
                        S1 = 100
                    Case Else
                        Select Case eb(N_comb) 'excentricit suivant le ct b
                            Case 0 'pas d'excentricit suivant le ct b
                                S1 = (p(1, N_comb) + P0 * ELU) / (b * (a - 2 * ea(N_comb)))
                            Case Is >= b / 2 ' rsultante au dela de la semelle
                                S1 = 100
                            Case Else
                                msg = "Charge normale excentr suivant les 2 ctes" & vbCrLf & "Non permis par cette version logicielle"
                                MsgBox(msg, MsgBoxStyle.Critical, title)
                        End Select
                End Select
            Case 2 'semelle filante arme
                Select Case ea(N_comb)  'excentricit suivant le ct a
                    Case 0 'pas d'excentricit suivant le ct a
                        S1 = (P0 * ELU + p(1, N_comb)) / a
                    Case Is >= a / 2 ' rsultante au dela de la semelle
                        S1 = 100
                    Case Else
                        S1 = (p(1, N_comb) + P0 * ELU) / (a - 2 * ea(N_comb))
                End Select
            Case 3 'semelle filante non arme
                If ea(N_comb) > 0.05 Then
                    Dim F_ea As String
                    Dim reponse As Integer
                    F_ea = Format(ea(N_comb) * 100, "##0.0")
                    msg = "Vous avez une excentricit de " & F_ea & " cm pour la combinaison " & CStr(N_comb) & vbCrLf & _
                    "Voulez-vous continuer ?"
                    reponse = MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.YesNo, title)
                    If reponse = 7 Then Exit Sub 'reponse NON
                End If
                S1 = (P0 * ELU + p(1, N_comb)) / a
        End Select
    End Sub
    Private Sub Contrainte_Sol_ELS(ByVal N_comb As Integer, ByRef lire As Integer)
        ' Calcul des Contraintes du Sol ELS

        Dim u1, P0, ea, eb, S62, s62r, s62p, ls As Double
        s62r = 0.75 : s62p = 1
        If comb(2, N_comb) = 1 Then S62 = s62r Else S62 = s62p
        Call Poids_Beton_Sol(P0) 'Poids de la Semelle et de la Terre
        ea = Abs((mty(2, N_comb) + hf * Hx(2, N_comb)) / (p(2, N_comb) + P0 * ELS))
        eb = Abs(mx(2, N_comb) + hf * Hy(2, N_comb) / (p(2, N_comb) + P0 * ELS))
        If ea = 0 And eb = 0 Then Exit Sub
        If ea >= a / 2 Or eb >= b / 2 Then lire = 1 : Exit Sub ' rsultante au dela de la semelle
        If ea = 0 Then 'calcul de la longueur de contact semelle-sol
            xb(N_comb) = 3 * (b / 2 - eb)  'Longueurs de Contact Semelle-Sol 
            xa(N_comb) = a
            If xb(N_comb) < S62 * b Then
                ls = b - xb(N_comb)
                Call message_soulevement(N_comb, ls)
            End If
        Else
            xa(N_comb) = 3 * (a / 2 - ea)
            xb(N_comb) = b
            If xb(N_comb) < S62 * b Then
                ls = b - xb(N_comb)
                Call message_soulevement(N_comb, ls)
            End If
        End If

    End Sub
    Private Sub Poids_Beton_Sol(ByRef P0 As Double)
        Dim volp, vols As Double
        ' Volume et Poids Beton et Sol
        Select Case geom
            Case 1  'semelle isol
                volp = pa * pb * (hf - h) 'Poteau
                vols = a * b * h 'Semelle
                P0 = dsb * (volp + vols) + dss * ((a * b * hf) - volp - vols)
            Case 2, 3 'semelle filante
                volp = Lvoile * 1 * (hf - h) 'voile
                vols = a * b * h 'Semelle,  b = 1 m
                P0 = dsb * (volp + vols) + dss * ((a * b * hf) - volp - vols)
        End Select
    End Sub
    Private Sub Calc_A_B_sans_moment(ByRef lire As Integer, ByVal N_comb As Integer, ByRef eA() As Double, ByRef eb() As Double)
        ' Valeurs de A et B sans Moment
        Dim S1, tol As Double
        If comb(1, N_comb) = 1 Then tol = 4 * tol1 / 3 Else tol = tol1 'combinaison avec vent
        Select Case geom
            Case 1  'semelle isole
                If choix = 6 Or choix = 7 Then 'ctes a et b imposes
                    Call Contrainte_Sol_ELU(N_comb, S1, ea, eb) 'Contraintes du Sol ELU
                    If S1 > tol * q Then lire = 1
                Else
                    Do While S1 > tol * q
                        Select Case choix
                            Case 1
                                a = a + 0.05 : b = b + 0.05
                            Case 2
                                a = a + 0.05 : b = b + 0.05
                                If a > aL Then a = aL
                            Case 3
                                a = aL : b = b + 0.05
                            Case 4
                                If a = aL And b = bL Then lire = 1 : Exit Sub
                                a = a + 0.05 : b = b + 0.05
                                If a > aL Then a = aL
                                If b > bL Then b = bL
                            Case 5
                                If b = bL Then lire = 1 : Exit Sub
                                b = b + 0.05
                                If b > bL Then b = bL
                        End Select
                        Call Calc_Hauteur_Semel(lire) : Call Contrainte_Sol_ELU(N_comb, S1, ea, eb) 'Hauteurs et Contraintes Sol
                    Loop
                End If
            Case 2, 3 'semelle filante
                If choix = 3 Or choix = 7 Then
                    If S1 > tol * q Then lire = 1
                Else
                    Do While S1 > tol * q
                        Select Case choix
                            Case 1
                                a = a + 0.05
                            Case 2
                                If a = aL Then lire = 1 : Exit Sub
                                a = a + 0.05
                                If a > aL Then a = aL
                        End Select
                        Call Calc_Hauteur_Semel(lire) : Call Contrainte_Sol_ELU(N_comb, S1, ea, eb) 'Hauteurs et Contraintes Sol
                    Loop
                End If
        End Select
    End Sub
    Private Sub Calc_A_B_avec_moment(ByRef lire As Integer, ByVal n_comb As Integer, ByRef eA() As Double, ByRef eb() As Double)
        ' VaIeur de A et B avec Moment(s)
        Dim S1, tol, vaire, ra, rb As Double
        If comb(1, n_comb) = 1 Then tol = 4 * tol1 / 3 Else tol = tol1 'combinaison avec vent
        Select Case choix
            Case 6
                Call Contrainte_Sol_ELU(n_comb, S1, ea, eb) 'Contraintes du Sol ELU
                If S1 > tol * q Then lire = 1
            Case 1 To 5
                vaire = 10000 : b8 = b
                Do
                    b = b8
                    If choix = 3 Or choix = 5 Then a = aL
                    Do
                        Call Calc_Hauteur_Semel(lire)
                        Call Contrainte_Sol_ELU(n_comb, S1, ea, eb) 'Hauteurs et Contraintes du Sol
                        If S1 <= tol * q Then
                            If a * b * h < vaire Then
                                vaire = a * b * h : ra = a : rb = b
                                Exit Do
                            End If
                        End If
                        b = b + 0.05
                    Loop While b <= bL
                    If S1 > tol * q And a = aL Then Exit Do
                    a = a + 0.05
                Loop While a <= aL

                If vaire = 10000 And S1 > tol * q Then lire = 1 : Exit Sub
                a = ra : b = rb
                Call Contrainte_Sol_ELU(n_comb, S1, ea, eb) : Call Calc_Hauteur_Semel(lire) 'rintroduit les bonnes valeurs h,s1
        End Select
    End Sub
    Private Sub Chainage_HA(ByVal ac As Double, ByRef nbar As Integer, ByRef phi As Double, _
                    ByRef il As Double, ByRef iret As Double, ByRef l As Double)

        Dim ip2, i2 As Integer
        Dim u1 As Double
        'recherche de la combinaison des diamtres d'acier la plus proche de la section calcule

        i2 = 1
        Do
            i2 = i2 + 1
            u1 = 2 * PI * dio(i2) ^ 2 / 4
        Loop While u1 < ac
        nbar = 2 : phi = dio(i2)
        il = 1000 : l = 1000
        iret = 0
    End Sub
    Private Sub Ferraillage_TS(ByVal ac As Double, ByVal A1 As Double, ByVal Asb As Double, ByRef lire As Integer, _
                                ByVal nasacomb As Integer, ByVal nasbcomb As Integer, ByVal ea() As Double, ByVal eb() As Double)
        Dim i2%, i3%, n1%, reponse%, m%
        Dim As1, As2, u1, u2, u3, u4, u5, espmin, phi, phi1, phi2 As Double
        Dim Sol_Lit(2) As Boolean
        Dim F_ac As String
        Dim diametre_long() As Single = {5.5, 6, 7, 6, 7, 9, 8, 9, 7, 7, 9}
        Dim espacement_longitudinal() As Integer = {200, 150, 150, 100, 100, 150, 100, 100, 150, 100, 100}
        Dim section_longitudinale() As Single = {1.19, 1.88, 2.57, 2.83, 3.85, 4.24, 5.03, 6.36, 2.57, 3.85, 6.36}
        Dim section_transversale() As Single = {1.19, 1.28, 1.28, 1.28, 1.28, 1.68, 1.68, 2.51, 2.57, 3.85, 6.36}
        reponse = 0
        Select Case geom
            Case 1 'semelle isole
                Sol_Lit(1) = False : Sol_Lit(2) = False
                u3 = 0 : u4 = 0 : u5 = 0 : nbLit = 1 : As1 = 1
                ac = ac / b : Asb = Asb / a 'cm --> cm/ml
                'calcul de As avec 1 lit
                i2 = 0
                Do
                    u1 = section_longitudinale(i2) / 10000.0#
                    phi1 = diametre_long(i2) / 1000
                    espmin = espacement_longitudinal(i2) / 1000
                    u3 = section_transversale(i2) / 10000.0#
                    i2 = i2 + 1
                    If i2 = 11 Then Exit Do
                Loop Until u1 > ac And u3 > Asb
                If u1 < ac Or u3 < Asb Then
                    Sol_Lit(1) = False
                    If nbLit = 1 And Sol_Lit(1) = False Then
                        msg = "Vous avez spcifi une solution  1 lit, or, aprs calcul," & vbCrLf & _
                        "2 lits de TS sont ncessaires. Voulez-vous continuer le calcul avec 2 lits " & vbCrLf & _
                        "(rponse=Oui) ou revenir aux donnes de calcul (rponse=Non) ?"
                        reponse = MsgBox(msg, MsgBoxStyle.YesNo Or MsgBoxStyle.Information, "Module de calcul")
                        If reponse = vbYes Then
                            As1 = 0 : nbLit = 2
                        Else
                            lire = 1
                            Exit Sub
                        End If
                    End If
                ElseIf u1 > ac And u3 > Asb Then
                    Sol_Lit(1) = True
                    As1 = u1
                    NLit_TS(1) = i2 - 1 'n de treillis suivant nomenclature ADETS
                End If
                'calcul de As avec 2 lits
                If nbLit = 2 Then
                    i2 = 0 : As2 = 0.1 '1000 cm
                    Do
                        u1 = section_longitudinale(i2) / 10000.0#
                        phi1 = diametre_long(i2) / 1000
                        espmin = espacement_longitudinal(i2) / 1000
                        u4 = section_transversale(i2) / 10000.0#
                        i2 = i2 + 1
                        i3 = i2 - 1
                        Do
                            u2 = section_longitudinale(i3) / 10000.0#
                            phi2 = diametre_long(i3) / 1000
                            espMax = espacement_longitudinal(i3) / 1000
                            u5 = section_transversale(i3) / 10000.0#
                            i3 = i3 + 1
                            If i3 = 11 Then Exit Do
                        Loop Until u1 + u2 > ac And u4 + u5 > Asb
                        If u1 + u2 > ac And u4 + u5 > Asb Then
                            Sol_Lit(2) = True
                            If u1 + u2 < As2 Then 'recherche de la quantit d'acier la + petite
                                As2 = u1 + u2
                                NLit_TS(2) = i2 - 1 : NLit_TS(3) = i3 - 1
                            End If
                        End If
                    Loop While i2 < 11
                    ' comparaison de As avec 2 lits et de As avec 1 lit
                    If Sol_Lit(2) = False Then
                        If u1 + u2 < ac Then F_ac = Format(ac * 10000, "#####.00")
                        If u4 + u5 < Asb Then F_ac = Format(Asb * 10000, "#####.00")
                        msg = "La section d'acier requise (" & F_ac & " cm) est trop importante et ne" & vbCrLf & _
                            "peut tre couverte avec 2 lits d'acier"
                        MsgBox(msg, MsgBoxStyle.OkOnly Or MsgBoxStyle.Information, "Module de calcul")
                        lire = 1
                        Exit Sub
                    End If
                    If As1 < As2 Then
                        Sol_Lit(1) = False : Sol_Lit(2) = True : nbLit = 2
                        m = NLit_TS(2) : NLit_TS(2) = NLit_TS(3) : NLit_TS(3) = m 'inversion pour avoir le TS le plus gros en bas
                    Else
                        Sol_Lit(1) = True : Sol_Lit(2) = False : nbLit = 1
                    End If
                End If
                'suivant sens //  A
                ac = ac * b : Asb = Asb * a
                If fis = 2 Then ac = ac / 1.1 : Asb = Asb / 1.1
                If fis = 3 Then ac = ac / 1.5 : Asb = Asb / 1.5
                Call Arret_barre(a, phi, ac, 1, nasacomb, ea)
                Call Ferraillage_Crochet_TS(ilA, iretA, la, a, ilB, iretB, lb, lire)
                If lire = 1 Then Exit Sub
                'suivant sens //  B
                Call Arret_barre(b, phi, Asb, 2, nasbcomb, eb)
                Call Ferraillage_Crochet_TS(ilATS, iretATS, laTS, b, ilBTS, IretBTS, lbTS, lire)
                If lire = 1 Then Exit Sub
            Case 2 'semelle filante arm
                Sol_Lit(1) = False : Sol_Lit(2) = False
                u3 = 0 : u4 = 0 : u5 = 0 : nbLit = 1 : As1 = 1
                'calcul de As avec 1 lit
                i2 = 0
                Do
                    u1 = section_longitudinale(i2) / 10000.0#
                    phi1 = diametre_long(i2) / 1000
                    espmin = espacement_longitudinal(i2) / 1000
                    u3 = section_transversale(i2)
                    i2 = i2 + 1
                Loop While u1 < ac And i2 < 8
                If u1 < ac Then
                    Sol_Lit(1) = False
                    If nbLit = 1 And Sol_Lit(1) = False Then
                        msg = "Vous avez spcifi une solution  1 lit, or, aprs calcul," & vbCrLf & _
                        "2 lits de TS sont ncessaires. Voulez-vous continuer le calcul avec 2 lits " & vbCrLf & _
                        "(rponse=Oui) ou revenir aux donnes de calcul (rponse=Non) ?"
                        reponse = MsgBox(msg, MsgBoxStyle.YesNo Or MsgBoxStyle.Information, "Module de calcul")
                        If reponse = vbYes Then
                            As1 = 0 : nbLit = 2
                        Else
                            lire = 1
                            Exit Sub
                        End If
                    End If
                Else
                    Sol_Lit(1) = True
                    As1 = u1
                    NLit_TS(1) = i2 - 1 'n de treillis suivant nomenclature ADETS
                End If
                'calcul de As avec 2 lits
                If nbLit = 2 Then
                    i2 = 0 : As2 = 0.1 '1000cm
                    Do
                        u1 = section_longitudinale(i2) / 10000.0#
                        phi1 = diametre_long(i2) / 1000
                        espmin = espacement_longitudinal(i2) / 1000
                        u4 = section_transversale(i2)
                        i2 = i2 + 1
                        i3 = i2 - 1
                        Do
                            u2 = section_longitudinale(i3) / 10000.0#
                            phi2 = diametre_long(i3) / 1000
                            espMax = espacement_longitudinal(i3) / 1000
                            u5 = section_transversale(i3)
                            i3 = i3 + 1
                            If i3 = 8 Then Exit Do
                        Loop Until u1 + u2 > ac
                        If u1 + u2 > ac Then
                            Sol_Lit(2) = True
                            If u1 + u2 < As2 Then 'recherche de la quantit d'acier la + petite
                                As2 = u1 + u2
                                NLit_TS(2) = i2 - 1 : NLit_TS(3) = i3 - 1
                            End If
                        End If
                    Loop While i2 < 8
                    ' comparaison de As avec 2 lits et de As avec 1 lit
                    If Sol_Lit(2) = False Then
                        F_ac = Format(ac * 10000, "#####.00")
                        msg = "La section d'acier requise (" & F_ac & " cm) est trop importante et ne" & vbCrLf & _
                            "peut tre couverte avec 2 lits d'acier"
                        MsgBox(msg, vbOKOnly, "Module de calcul")
                        lire = 1
                        Exit Sub
                    End If
                    If As1 > As2 Then
                        Sol_Lit(1) = False : Sol_Lit(2) = True : nbLit = 2
                    Else
                        Sol_Lit(1) = True : Sol_Lit(2) = False : nbLit = 1
                    End If
                End If
                'section d'acier dans le sens longitudinal
                'le plus simple est de rajouter une barre dans le sens longitudinal car la section d'
                'acier demand sera toujours petite
                If nbLit = 1 Then
                    If (u3 * a) / 10000 < Asb Then
                        i2 = 0
                        Do
                            i2 = i2 + 1
                            u1 = (u3 / 10000) + PI * dio(i2) ^ 2 / 4
                        Loop While u1 < Asb
                        nbarB = 1 : phib = dio(i2)
                    End If
                Else
                    If ((u5 + u4) * a) / 10000 < Asb Then
                        i2 = 0
                        Do
                            i2 = i2 + 1
                            u1 = (u5 + u4) / 10000 + PI * dio(i2) ^ 2 / 4
                        Loop While u1 < Asb
                        nbarB = 1 : phib = dio(i2)
                    End If
                End If
                'suivant sens //  A
                Call Arret_barre(A1, phi, ac, 1, nasacomb, ea)
                Call Ferraillage_Crochet_TS(ilA, iretA, la, a, ilB, iretB, lb, lire)
                If lire = 1 Then Exit Sub
            Case 3 'semelle filante non arme
                i2 = 0
                phi = diametre_long(i2) / 1000
                espmin = espacement_longitudinal(i2) / 1000
                A1 = A1 - 2 * enr
                n1 = CInt(A1 / espmin) + 1
                u1 = n1 * PI * phi ^ 2 / 4
                Do While u1 < ac
                    i2 = i2 + 1
                    If i2 > 8 Then Exit Do
                    phi = diametre_long(i2) / 1000
                    espmin = espacement_longitudinal(i2) / 1000
                    n1 = CInt(A1 / espmin) + 1
                    u1 = n1 * PI * phi ^ 2 / 4
                    nbarB = n1 : phib = phi ' nbarB, phib, ilB, iretB, lb
                    iretB = 0 : ilB = 0 : lb = 0
                Loop
                NLit_TS(1) = i2  'n de treillis suivant nomenclature ADETS
        End Select
    End Sub
    Private Sub Ferraillage_Crochet_TS(ByRef il As Double, ByRef iret As Double, ByRef l As Double, ByVal A1 As Double, _
                        ByRef il1 As Double, ByRef iret1 As Double, ByRef l1 As Double, ByRef lire As Integer)
        Dim reponse As Integer
        Dim u1 As Double
        Dim diametre_long() As Single = {5.5, 6, 7, 6, 7, 9, 8, 9, 7, 7, 9}
        Dim diametre_trans() As Single = {5.5, 7, 7, 7, 7, 8, 8, 8, 7, 7, 9}
        il1 = 0 : iret1 = 0 : l1 = 0
        Select Case Icrochet
            Case 1  'TS avec crochets !!!
                If crochet_TS = False Then
                    msg = "Vous avez spcifi une solution sans crochet, or, aprs calcul, l'ancrage" & vbCrLf & _
                        "du TS ncessite des crochets. Voulez-vous continuer le calcul" & vbCrLf & _
                        "(rponse=Oui) ou revenir aux donnes de calcul (rponse=Non) ?"
                    reponse = MsgBox(msg, MsgBoxStyle.YesNo Or MsgBoxStyle.Information, "Module de calcul")
                    If reponse = vbNo Then lire = 1 : Exit Sub
                End If
                Select Case nbLit
                    Case 1
                        If A1 = a Then phi = diametre_long(NLit_TS(1)) Else phi = diametre_trans(NLit_TS(1))
                        phi = phi / 1000
                        u1 = A1 - 2 * enr - 2 * (rm + 1) * phi + (angle1 * PI / 180 * (rm + 0.5) * phi) * 2 + xlam * phi * 2
                        il = Int(u1 * 100 + 1) / 100
                        iret = xlam * phi  ' A.6.1,255
                        iret = Int(iret * 100 + 0.5) / 100
                        l = A1 - 2 * enr
                    Case 2  '2 lits
                        If A1 = a Then phi = diametre_long(NLit_TS(2)) Else phi = diametre_trans(NLit_TS(2))
                        phi = phi / 1000
                        u1 = A1 - 2 * enr - 2 * (rm + 1) * phi + (angle1 * PI / 180 * (rm + 0.5) * phi) * 2 + xlam * phi * 2
                        il = Int(u1 * 100 + 1) / 100
                        iret = xlam * phi  ' A.6.1,255
                        iret = Int(iret * 100 + 0.5) / 100
                        l = A1 - 2 * enr
                        If A1 = a Then phi = diametre_long(NLit_TS(3)) Else phi = diametre_trans(NLit_TS(3))
                        phi = phi / 1000
                        u1 = A1 - 2 * enr - 2 * (rm + 1) * phi + (angle1 * PI / 180 * (rm + 0.5) * phi) * 2 + xlam * phi * 2
                        il1 = Int(u1 * 100 + 1) / 100
                        iret1 = xlam * phi  ' A.6.1,255
                        iret1 = Int(iret1 * 100 + 0.5) / 100
                        l1 = A1 - 2 * enr
                End Select
            Case 2  'TS sans crochets
                Select Case nbLit
                    Case 1
                        iret = 0
                        il = A1 - 2 * enr
                        l = A1 - 2 * enr
                    Case 2
                        iret = 0 : iret1 = 0
                        il = A1 - 2 * enr : il1 = il
                        l = A1 - 2 * enr : l1 = l
                End Select
            Case 3  'TS en portefeuille
                'TS superposs l'un sur l'autre L et 0.75L
                iret = 0 : iret1 = 0
                il = A1 - 2 * enr
                l = A1 - 2 * enr
                l1 = 0.75 * A1
                l1 = Int(l1 * 10 + 0.5) / 10
                il1 = l1
        End Select
    End Sub
    Private Sub Calcul_tassement()
        Dim AireTotale, Aire(16), E(16), E1, E2, EA, EB, EMm, Elim1, Elim2 As Double
        Dim Hlimite_basse, Hlimite_haute, inve35, inve68, inve916, LamdaC, LamdaD, N As Double
        Dim Sigma, Z1, Z2 As Double
        Dim i, i1, i2, ind, j, Nem As Integer
        St = 0 : Sc = 0 : Sd = 0
        For i = 1 To 16 : Aire(i) = 0 : Next i
        'calcul de EM
        'dtermination du nombre de modules pressiomtriques renseigns
        i = 1
        Do While z(i) <> 0
            i = i + 1
            If i = 17 Then Exit Do
        Loop
        Nem = i - 1
        '-->Calcul de E1, E2, E3, ..., E16
        For j = 1 To 16
            i = 1 : E1 = 0
            Hlimite_basse = hf + (j - 1) * (b / 2)
            Do While z(i) <= Hlimite_basse
                E1 = EM(i) : Z1 = z(i) : i1 = i
                i = i + 1
                If i = 17 Then Exit Do
            Loop
            i = 1 : E2 = 0 : Hlimite_haute = hf + j * (b / 2)
            For i = 1 To Nem
                If z(i) >= Hlimite_haute Then
                    E2 = EM(i) : Z2 = z(i) : i2 = i
                    Exit For
                End If
            Next i
            If E1 = 0 Then
                If j = 1 Then
                    Z1 = 0 : E1 = 0 : i1 = 0
                Else
                    Z1 = Hlimite_basse : E1 = EM(Nem) : i1 = Nem
                End If
            End If
            If E2 = 0 Then E2 = EM(Nem) : Z2 = Hlimite_haute : i2 = Nem + 1
            If Z1 = Hlimite_basse Then
                Elim1 = E1
            Else
                Elim1 = ((((EM(i1 + 1) - E1) / (z(i1 + 1) - Z1))) * (Hlimite_basse - Z1)) + E1
            End If
            If Z2 = Hlimite_haute Then
                Elim2 = E2
            Else
                Elim2 = ((((E2 - EM(i2 - 1)) / (Z2 - z(i2 - 1)))) * (Hlimite_haute - z(i2 - 1))) + EM(i2 - 1)
            End If
            For i = 1 To 16 : Aire(i) = 0 : Next i
            If i2 > i1 + 1 Then
                ind = i2 - i1
                Aire(1) = (Elim1 + EM(i1 + 1)) * (z(i1 + 1) - Hlimite_basse) / 2
                Aire(2) = (Elim2 + EM(i2 - 1)) * (Hlimite_haute - z(i2 - 1)) / 2
                If ind > 2 Then
                    For i = 1 To ind - 2
                        Aire(2 + i) = (EM(i1 + 1) + EM(i1 + 2)) * (z(i1 + 2) - z(i1 + 1)) / 2
                    Next i
                End If
            Else
                Aire(1) = (Elim2 + Elim1) * (Z2 - Z1) / 2
            End If
            AireTotale = 0 : i = 1
            Do While Aire(i) <> 0
                AireTotale = AireTotale + Aire(i)
                i = i + 1
            Loop
            E(j) = AireTotale / (b / 2)
        Next j
        '--> calcul de E3,5
        inve35 = (1 / E(3)) + (1 / E(4)) + (1 / E(5))
        '--> calcul de E6,8
        inve68 = (1 / E(6)) + (1 / E(7)) + (1 / E(8))
        '--> calcul de E9,16
        inve916 = (1 / E(9)) + (1 / E(10)) + (1 / E(11)) + (1 / E(12)) + (1 / E(13)) + (1 / E(14)) + (1 / E(15)) + (1 / E(16))
        '-->calcul de EM
        EMm = (1 / E(1)) + (1 / (0.85 * E(2))) + inve35 + ((1 / 2.5) * inve68) + (inve916 * (1 / 2.5))
        EMm = 4 / EMm
        'calcul de Lc, Ld
        Select Case a / b
            Case Is <= 1
                LamdaC = 1.1
                LamdaD = 1.12
            Case Is <= 2
                LamdaC = 1.2
                LamdaD = 1.53
            Case Is <= 3
                LamdaC = 1.3
                LamdaD = 1.78
            Case Is <= 5
                LamdaC = 1.4
                LamdaD = 2.14
            Case Else
                LamdaC = 1.5
                LamdaD = 2.65
        End Select
        'Calcul de la contrainte normale
        N = p(2, 1)
        For i = 2 To 4
            If p(2, i) > N Then N = p(2, i)
        Next i
        Sigma = N / (a * b)
        'Calcul tassement de consolidation Sc
        Sc = alpha * Sigma * LamdaC * b / (9 * E(1))
        'calcul tassement dviatorique
        Sd = 2 * Sigma * 0.6 * (LamdaD * b / 0.6) ^ alpha
        Sd = Sd / (9 * EMm)
        'calcul du tassement total
        St = Sc + Sd
    End Sub
End Module
